﻿Public Class RPmp4barpio
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PMP4BARPIO.C
  '
  '            < RPMP4BARPIO.BAS >
  '
  '       2011.10.11   CREATED BY N. IWATSUKI
  '       2018. 4.19  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 3 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim TM(202) As Double ' Time
  Dim SI(202), DSI(202), DDSI(202) As Double ' Displacement of inpou slider
  Dim SO(202), DSO(202), DDSO(202) As Double ' Displacement of ouyput slider
  Dim XGI, YGI, XGO, YGO, XS, XF As Double
  Dim PSII, PSIO As Double
  Dim GSII, ETAI, GSIO, ETAO As Double
  Dim L, OPTIME, TFIN As Double
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i, k As Integer
    Dim CPI, SPI, CPO, SPO As Double
    Dim X0, X1, X2, X3, Y0, Y1, Y2, Y3 As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    '
PAGE1:
    FileOpen(1, "../../../PMP4BARPIO.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, XGI) : Input(1, YGI)
    Input(1, PSII)
    Input(1, GSII) : Input(1, ETAI)
    Input(1, XGO) : Input(1, YGO)
    Input(1, PSIO)
    Input(1, GSIO) : Input(1, ETAO)
    Input(1, L)
    Input(1, XS) : Input(1, XF)
    Input(1, OPTIME)
    '
    ND = 201
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, TM(i))
      Input(1, SI(i)) : Input(1, DSI(i)) : Input(1, DDSI(i))
      Input(1, SO(i)) : Input(1, DSO(i)) : Input(1, DDSO(i))
    Next i
    FileClose(1)
    PSII = PSII * DR
    PSIO = PSIO * DR
    TFIN = TM(ND)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Input/output motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 1.6 ' Maximum values of axes
    XANAME = "Time sec" : YANAME = "ｓ_i@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = SI(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "Time sec" : YANAME = "ｓ^^・@_i@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DSI(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "ｓ^^‥@_i@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT
      YPLOT(i) = DDSI(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    '
    X0PLOT = 2.0 : Y0PLOT = 1.6 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 1.6 ' Maximum values of axes
    XANAME = "Time sec" : YANAME = "ｓ_o@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = SO(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.6 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "Time sec" : YANAME = "ｓ^^・@_o@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DSO(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.6 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = TFIN : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "ｓ^^‥@_o@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT
      YPLOT(i) = DDSO(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 10.0 ' Final position of axes
    NXPLOT = 5 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -0.5 ' Minimum values of axes
    XMAXPLOT = 1.5 : YMAXPLOT = 1.5 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    GAXES(graph) ' Axes plot
    '
    NDPLOT = 2
    CPI = Math.Cos(PSII)
    SPI = Math.Sin(PSII)
    CPO = Math.Cos(PSIO)
    SPO = Math.Sin(PSIO)
    '
    NDPLOT = 2
    XPLOT(1) = XGI
    YPLOT(1) = YGI
    XPLOT(2) = XPLOT(1) + 1.0 * CPI
    YPLOT(2) = YPLOT(1) + 1.0 * SPI
    NUMPEN = 7
    SLINE(graph)
    XPLOT(1) = XGO
    YPLOT(1) = YGO
    XPLOT(2) = XPLOT(1) + 1.3 * CPO
    YPLOT(2) = YPLOT(1) + 1.3 * SPO
    NUMPEN = 7
    SLINE(graph)
    '
    For k = 1 To ND Step 10
      X0 = SI(k) * CPI + XGI
      Y0 = SI(k) * SPI + YGI
      X1 = (SI(k) + GSII) * CPI - ETAI * SPI + XGI
      Y1 = (SI(k) + GSII) * SPI + ETAI * CPI + YGI
      X2 = (SO(k) + GSIO) * CPO - ETAO * SPO + XGO
      Y2 = (SO(k) + GSIO) * SPO + ETAO * CPO + YGO
      X3 = SO(k) * CPO + XGO
      Y3 = SO(k) * SPO + YGO
      '
      NDPLOT = 4
      XPLOT(1) = X0
      YPLOT(1) = Y0
      XPLOT(2) = X1
      YPLOT(2) = Y1
      XPLOT(3) = X2
      YPLOT(3) = Y2
      XPLOT(4) = X3
      YPLOT(4) = Y3
      NUMPEN = 1
      SLINE(graph)
      '
      XPLOT(2) = X3
      YPLOT(2) = Y3
      '
      NDPLOT = 2
      NUMPEN = 2
      PCPLOT(graph)
      '
      XPLOT(1) = X1
      YPLOT(1) = Y1
      XPLOT(2) = X2
      YPLOT(2) = Y2
      '
      NDPLOT = 2
      NUMPEN = 1
      CPLOT(graph)
    Next k
    NDPLOT = ND
    '
    GoTo PEND
    '
PAGE3:
    For k = 1 To ND Step 10
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 10.0 : YFPLOT = 10.0 ' Final position of axes
      NXPLOT = 5 : NYPLOT = 4 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
      XMINPLOT = -1.0 : YMINPLOT = -0.5 ' Minimum values of axes
      XMAXPLOT = 1.5 : YMAXPLOT = 1.5 ' Maximum values of axes
      XANAME = "X m" : YANAME = "Y m" ' Name of axes
      NDPLOT = ND ' Number of data
      PSCALE() ' Scaling
      GAXES(graph) ' Axes plot
      '
      NDPLOT = 2
      CPI = Math.Cos(PSII)
      SPI = Math.Sin(PSII)
      CPO = Math.Cos(PSIO)
      SPO = Math.Sin(PSIO)
      '
      NDPLOT = 2
      XPLOT(1) = XGI
      YPLOT(1) = YGI
      XPLOT(2) = XPLOT(1) + 1.0 * CPI
      YPLOT(2) = YPLOT(1) + 1.0 * SPI
      NUMPEN = 7
      SLINE(graph)
      XPLOT(1) = XGO
      YPLOT(1) = YGO
      XPLOT(2) = XPLOT(1) + 1.3 * CPO
      YPLOT(2) = YPLOT(1) + 1.3 * SPO
      NUMPEN = 7
      SLINE(graph)
      '
      X0 = SI(k) * CPI + XGI
      Y0 = SI(k) * SPI + YGI
      X1 = (SI(k) + GSII) * CPI - ETAI * SPI + XGI
      Y1 = (SI(k) + GSII) * SPI + ETAI * CPI + YGI
      X2 = (SO(k) + GSIO) * CPO - ETAO * SPO + XGO
      Y2 = (SO(k) + GSIO) * SPO + ETAO * CPO + YGO
      X3 = SO(k) * CPO + XGO
      Y3 = SO(k) * SPO + YGO
      '
      NDPLOT = 4
      XPLOT(1) = X0
      YPLOT(1) = Y0
      XPLOT(2) = X1
      YPLOT(2) = Y1
      XPLOT(3) = X2
      YPLOT(3) = Y2
      XPLOT(4) = X3
      YPLOT(4) = Y3
      NUMPEN = 1
      SLINE(graph)
      '
      XPLOT(2) = X3
      YPLOT(2) = Y3
      '
      NDPLOT = 2
      NUMPEN = 2
      PCPLOT(graph)
      '
      XPLOT(1) = X1
      YPLOT(1) = Y1
      XPLOT(2) = X2
      YPLOT(2) = Y2
      '
      NDPLOT = 2
      NUMPEN = 1
      CPLOT(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Kinematic Analysis of Planar 4-Bar Linkage "
    PSYMBOL(graph)
    '
    PXSYMBOL = 2.0 : PYSYMBOL = 16.5
    SYMBOL = "with Input/Output Slider by RPMP4BARPIO.BAS"
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
