//-----------------------------------------------------
// 
//  @@ i΋o͕ʂU߃N@\̉^w
//
//             < mp6barpo.cpp >
//
//   L[4]     : ߒ
//   gsi[2], eta[2] :
//              Ԑ߂̕`_̓W
//   PG       : i΋̃KCh̋K_Ƃ̔
//   psi      : i΋̃KCh̎ppƂ̔ 
//   minv[2]  : @\]̃CWP[^
//   theta    : ߊpψʁEpxEpx
//   J[7]     : ΋̈ʒuExEx
//   s        : o͐ߕψʁExEx
//   ichk     : G[CWP[^
//                 ichk = 991 : QAJ3J2J1\łȂ
//                 ichk = 992 : QAJ4J5J6\łȂ
//
//     ** KvTuvO **
//           crank_input
//           RRR_links
//           coupler_point
//           PRR_links
//
//     2002. 3.22 쐬 BY ╍
//     2011.10. 9  BY ╍
//
//-----------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"

int MP6BARPO( double L[], double gsi[], double eta[], POINT PG, ANGLE psi, ANGLE theta, POINT J[], VARIABLE *s )
{
	ANGLE dumma;
	POINT dummp;
	int ichk;
	int minv[2];

	dumma.the = dumma.dthe = dumma.ddthe = 0.0;
	dummp.P.x = dummp.DP.x = dummp.DDP.x = 0.0;
	dummp.P.y = dummp.DP.y = dummp.DDP.y = 0.0;

//------ ΋̕ψʁExEx ------

	minv[0] = 1;
	minv[1] = 1;

	crank_input( J[0], L[0], theta, dumma, &J[1] );

	ichk = RRR_links( J[3], J[1], L[2], L[1], minv[0],  &J[2] );
	if( ichk !=SUCCESS ) return ( 991 );

	coupler_point( J[2], J[1], gsi[0], eta[0],  &J[4], &dumma );

	ichk = PRR_links( J[4], L[3], PG, psi, gsi[1], eta[1], minv[1], s, &J[6], &J[5] );
	if( ichk !=SUCCESS ) return ( 992 );

	return ( SUCCESS );
}
