//----------------------------------------------------------
//
//  @@ i΋o͕ʂU߃N@\̋t͊w͌vZ 
//@@@@@ߓ]̏ꍇ 
//
//             < pidp6barpo.cpp >
//
//   L[4]     : ߒ
//   gsi[2], eta[2] :
//              Ԑ߂̕`_̓W
//   PG       : i΋̃KCh̋K_Ƃ̔
//   psi      : i΋̃KCh̎ppƂ̔ 
//   theta    : ߊpψʁEpxEpx
//   J[7]     : ΋̈ʒuExEx
//   s        : o͐ߕψʁExEx
//   gsig[5], etag[5]
//            : ߂̏dS̓W
//   M[5]     : ߂̎
//   I[5]     : ߂̏dS̊[g
//   fe       : O
//
//   CG[5]    : ߂̏dS̈ʒuExEx
//   phig[5]  : ߂̎ppEpxEpx
//   fjx[7], fjy[7] :
//              ΋p
//   tauj6    : o͐߂̑΋p[g
//   taui     : 쓮gN 
//
//   ierg     : G[CWP[^@KEX̏@
//   ichk     : G[CWP[^
//                 ichk = 991 : QAJ3J2J1\łȂ
//                 ichk = 992 : QAJ4J5J6\łȂ
//
//     ** KvTuvO **
//           DRMP6BARPO
//           DRGP6BARPO
//           MP6BARPO
//           GRVP6BARPO
//           IDP6BARPO
//           GAUSS
//
//     ** Kvf[^t@C **
//          IMDATA.dat
//          IGDATA.dat
//
//     ** o̓f[^t@C **
//           PIDP6BARPO.dat
//           PIDP6BARPO.csv
//           PIDP6BARPO.trj
//
//     2002. 3.22 쐬 BY ╍
//     2011.10. 9  BY ╍
//     2018. 4.19  BY ╍
//
//-----------------------------------------------------------

#include <stdio.h> 
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"
#include "Pidp6barpo_subfunctions.h"

void main(void)
{
	double L[4];			// ߒ
	double gsi[2], eta[2];	// Ԑߕ`_̓W
	double gsig[5], etag[5];
					    	// ߂̏dS̈ʒuExEx
	double M[5], I[5];      // ߂̎ʁEdS̊[g
	double fe;              // o͐߂ɍpO
	ANGLE theta;			// ߊpψʁEpxEp
	POINT PG;               // i΋̃KCh̋K_Ƃ̔
    ANGLE psi;              // i΋̃KCh̎ppƂ̔ 
	POINT J[7];				// ΋̈ʒuExEx
	VARIABLE s;				// o͐ߕψʁExEx
	POINT CG[5];			// ߂̏dS̈ʒuExEx
	ANGLE phig[5];			// ߂̎ppEpxEpx
	double fjx[7], fjy[7];
					    	// ΋p
	double tauj6;           // o͐߂ɂ悤΋p[g
	double taui;            // 쓮gN

	double rpm;				// ߉]x
	double th;				// ߊpψ
	char   name[100];	    // vZҎ

	FILE *fpDAT, *fpCSV, *fpTRJ;    // t@C|C^

	int i, ith;             // ƕϐ
	int ichk;               // G[CWP[^
	double tmpf[10];


//------ f[^ ------

	printf("** ́F "); 
	gets_s(name);
	printf("\n");

    DRMP6BARPO( L, gsi, eta, &PG, &psi, J );
	DRGP6BARPO( gsig, etag, M, I );

	printf("** ߉]x [RPM]F\n");
	finput_val( tmpf, 1 );
	  rpm = tmpf[0];

	theta.dthe = rpm*360/60*DR;
	theta.ddthe = 0;

	printf("** o͐߂ɍpO(FE) [N]F\n");
	finput_val( tmpf, 1 );
	  fe = tmpf[0];

//------ o̓f[^@CI[v (PIDP6BARPO.DAT,PIDP6BARPO.CSVj------

	if( fopen_s( &fpDAT, "PIDP6BARPO.DAT","wt" ) != SUCCESS ){
		printf("++G[F t@C PIDP6BARPO.DAT J܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PIDP6BARPO.CSV","wt" ) != SUCCESS ){
		printf("++G[F t@C PIDP6BARPO.CSV J܂I\n");
		exit(0);
	}
	if( fopen_s( &fpTRJ, "PIDP6BARPO.TRJ","wt" ) != SUCCESS ){
		printf("++G[F t@C PIDP6BARPO.TRJ J܂I\n");
		exit(0);
	}

//------ o ------

	fprintf(fpDAT, " by %s\n", name);
	fprintf(fpDAT, "by PIDP6BARPO.CPP\n");
	fprintf(fpDAT, "%13.5f %13.5f\n", J[0].P.x, J[0].P.y);
	fprintf(fpDAT, "%13.5f %13.5f\n", J[3].P.x, J[3].P.y);
	for( i=0; i<4; i++ ) {
		fprintf(fpDAT, "%13.5f \n ", L[i] );
	}
	for( i=0; i<2; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f\n", gsi[i], eta[i] );
	}
	fprintf(fpDAT, "%13.5f %13.5f\n", PG.P.x, PG.P.y );
	fprintf(fpDAT, "%13.5f\n", psi.the*RD );
	for( i=0; i<5; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f %13.5f %13.5f\n", gsig[i], etag[i], M[i], I[i] );
    }
	fprintf(fpDAT, "%13.5f\n", fe );
	fprintf(fpDAT, "%13.5f\n", rpm);

	fprintf(fpCSV, "%s\n", name);
	fprintf( fpCSV, "The,S,Xp,Yp,Taui\n");

//------ C[v ------

	for( ith=0; ith<=360; ith++ ){
		th = (double)ith;
		theta.the = th*DR;
		
		ichk = MP6BARPO( L, gsi, eta, PG, psi, theta, J, &s );
		if( ichk != SUCCESS ) {
			printf( "\n ++ G[ MP6BARPO! ier= %d \n", ichk );
			exit ( 0 );
		}

		GRVP6BARPO( gsig, etag, J, CG, phig );

		ichk = IDP6BARPO( M, I, J, psi, CG, phig, fe, fjx, fjy, &tauj6, &taui );
		if( ichk != SUCCESS ) {
			printf( "\n ++ G[ IDP6BARPO ! ier = %d \n", ichk );
			exit ( 0 );
		}

		fprintf(fpDAT, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f\n",
			    th, s.v,  J[4].P.x, J[4].P.y, 
				fjx[0], fjy[0], fjx[1], fjy[1], fjx[2], fjy[2], fjx[3], fjy[3], fjx[4], fjy[4], fjx[5], fjy[5],
				fjy[6], tauj6, taui );

		fprintf(fpCSV, "%7.1f, %13.5f, %13.5f, %13.5f, %13.5f\n",
			    th, s.v, J[4].P.x, J[4].P.y, taui );

		fprintf(fpTRJ, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f\n",
			    th, 
				J[0].P.x, J[0].P.y, J[1].P.x, J[1].P.y, J[2].P.x, J[2].P.y, J[3].P.x, J[3].P.y,
				J[4].P.x, J[4].P.y, J[5].P.x, J[5].P.y, J[6].P.x, J[6].P.y   );

		printf("%7.1f %13.5f %13.5f %13.5f %13.5f\n",
			    th, s.v, J[4].P.x, J[4].P.y, taui );

	}

	fclose( fpDAT );
	fclose( fpCSV );
	fclose( fpTRJ );
}

