//------------------------------------------------
//
//   RRxʂUߒP[vr@\̑^̎Ԋ֐vZ
//@@@@T◯֐쓮̏ꍇ
//
//          < eempolleg.cpp >
//
//   XPS      : o͓_̊JnXʒu
//   XPF      : o͓_̏IXʒu
//   YPS      : o͓_̊JnYʒu
//   YPF      : o͓_̏IYʒu
//   PHIS     : ̊Jnpp
//   PHIF     : ̏Ipp
//   op_time  : Ǝ
//   PF       : ̏o͓_̈ʒuExEx
//   PHI      : ̎ppEpxEpx
//
//     2023. 5. 4 쐬  BY ╍
//   
//------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "cal.h"
#include "personalio.h"
#include "mech.h"

void EEMPOLLEG(
           double XPS, double XPF, 
		   double YPS, double YPF,
		   double PHIS, double PHIF,
		   double DELXP, double DELYP,double DELPHI,
		   double op_time, double time,
		   POINT *PF, ANGLE *PHI
)
{
	double r,r2,r3,r4,r5, rr, drr, ddrr;    

	if( time < 0 ){
		PF->P.x = XPS;
		PF->DP.x = PF->DDP.x = 0.0;
		PF->P.y = YPS;
		PF->DP.y = PF->DDP.y = 0.0;
        PHI->the = PHIS;
        PHI->dthe = PHI->ddthe = 0.0;
		return;
	}
		
	if( time > op_time ){
		PF->P.x = XPF;
		PF->DP.x = PF->DDP.x = 0.0;
		PF->P.y = YPF;
		PF->DP.y = PF->DDP.y = 0.0;
        PHI->the = PHIF;
        PHI->dthe = PHI->ddthe = 0.0;
		return;
	}

	r = time/op_time;        // T◯֐
	r2 = r*r;
	r3 = r2*r;
	r4 = r3*r;
	r5 = r4*r;

	rr = 6.0*r5 - 15*r4 + 10*r3;
	drr = (30.0*r4 - 60.0*r3 + 30.0*r2 ) / op_time;
	ddrr = (120.0*r3 - 180.0*r2 + 60.0*r) / op_time / op_time;

	PF->P.x = DELXP * rr + XPS;
	PF->DP.x = DELXP*drr;
	PF->DDP.x = DELXP*ddrr;
	PF->P.y = DELYP*rr + YPS;
	PF->DP.y = DELYP*drr;
	PF->DDP.y = DELYP*ddrr;
	PHI->the = DELPHI * rr + PHIS;
	PHI->dthe = DELPHI * drr;
	PHI->ddthe = DELPHI * ddrr;
}
