//------------------------------------------------------
//
//   RRxʂUߒP[vr@\̊֐ߋ쓮vZ
//@@@@T◯֐쓮̏ꍇ
//
//          < jntpolleg.cpp >
//
//   start_angle[3]  : Jn֐ߊp
//   final_angle[3]  : I֐ߊp
//   delta_angle[3]  : ֐ߊp쓮
//   op_time         : Ǝ
//   time            : 
//   theta[3]        : ֐ߊpEpxEpx
//
//     2023. 4.27 쐬  BY ╍
//
//------------------------------------------------------
//
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "cal.h"
#include "personalio.h"
#include "mech.h"

void JNTPOLLEG ( double start_angle[], double final_angle[], double delta_angle[], ANGLE theta[],
           double op_time, double time)
{
	double r,r2,r3,r4,r5;    
	int j;                  

	if( time<=0.0 ){                                              // ֐ߊpEpxEpx
		for(j=0; j<3; j++){
			theta[j].the = start_angle[j];
			theta[j].dthe = 0.0;
			theta[j].ddthe = 0.0;
		}
	}
	else{
		if( time>=op_time ){                                 
			for(j=0; j<3; j++){
				theta[j].the = final_angle[j];
				theta[j].dthe = 0.0;
				theta[j].ddthe = 0.0;
			}
		}
		else {
			r = time/op_time;                                        // T◯֐
			r2 = r*r;
			r3 = r2*r;
			r4 = r3*r;
			r5 = r4*r;
			for(j=0; j<3; j++){
				theta[j].the = delta_angle[j] * (6.0*r5 - 15.0*r4 + 10.0*r3) + start_angle[j];
				theta[j].dthe = delta_angle[j]/op_time * (30.0*r4 - 60.0*r3 + 30.0*r2);
				theta[j].ddthe = delta_angle[j] / op_time / op_time * (120.0*r3 - 180.0*r2 + 60.0*r);
			}
		}
	}
}
