﻿Public Class RPmquadleg
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PMQUADLEG.C
  '
  '            < RPMQUADLEG.BAS >
  '
  '       2015. 5.17   CREATED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 7 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim THE(362) As Double ' Crank angle
  Dim XJ(362, 18), YJ(362, 18) As Double ' Joint position
  Dim X(9), Y(9) As Double ' Joint position
  Dim L(5) As Double ' Link lengths
  Dim GSI(3), ETA(3) As Double ' Position of coupler point
  Dim THE0 As Double ' Initial crank angle 
  Dim DTHE As Double ' Constant crank angular velocity
  Dim PHI(361), XG(361), YG(361), XSRD(361), YSRD(361), XFFD(361), YFFD(361), XFRD(361), YFRD(361) As Double
  Dim P_plotleg As Integer
  Dim ND As Integer ' Number of data
  Dim NDPLOTH As Integer
  Dim LEGPOS As Integer ' Leg position
  Dim LPC As Integer
  Dim BLINKCOLOR, MLINKCOLOR, JOINTCOLOR As Integer
  '
  Private Sub Exe()
    Dim i, k As Integer
    Dim DUM, CP, SP As Double
    Dim XSF, YSF, XSR, YSR, XFF, YFF, XFR, YFR As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    If P_page = 6 Then GoTo PAGE6
    If P_page = 7 Then GoTo PAGE7
    '
PAGE1:
    FileOpen(1, "../../../PMQUADLEG.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, X(1)) : Input(1, Y(1))
    Input(1, X(7)) : Input(1, Y(7))
    For i = 0 To 4 Step 1
      Input(1, L(i))
    Next i
    For i = 0 To 2 Step 1
      Input(1, GSI(i)) : Input(1, ETA(i))
    Next i
    Input(1, THE0)
    Input(1, DTHE)
    '
    ND = 361
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, XJ(i, 0)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 0)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 1)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 1)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 2)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 2)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 3)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 3)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 4)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 4)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 5)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 5)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 6)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 6)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 7)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 7)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 8)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 8)) : Input(1, DUM) : Input(1, DUM)
      Input(1, THE(i))
      Input(1, XJ(i, 9)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 9)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 10)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 10)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 11)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 11)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 12)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 12)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 13)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 13)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 14)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 14)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 15)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 15)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 16)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 16)) : Input(1, DUM) : Input(1, DUM)
      Input(1, XJ(i, 17)) : Input(1, DUM) : Input(1, DUM)
      Input(1, YJ(i, 17)) : Input(1, DUM) : Input(1, DUM)
    Next i
    FileClose(1)
    '
    NDPLOTH = 181
    For i = 1 To NDPLOTH Step 1
      PHI(i) = -Math.Atan((YJ(i, 4) - YJ(i, 17)) / (XJ(i, 4) - XJ(i, 17)))
      CP = Math.Cos(PHI(i))
      SP = Math.Sin(PHI(i))
      XSF = XJ(i, 4) * CP - YJ(i, 4) * SP
      YSF = XJ(i, 4) * SP + YJ(i, 4) * CP
      XSR = XJ(i, 17) * CP - YJ(i, 17) * SP
      YSR = XJ(i, 17) * SP + YJ(i, 17) * CP
      XFF = XJ(i, 13) * CP - YJ(i, 13) * SP
      YFF = XJ(i, 13) * SP + YJ(i, 13) * CP
      XFR = XJ(i, 8) * CP - YJ(i, 8) * SP
      YFR = XJ(i, 8) * SP + YJ(i, 8) * CP
      XG(i) = -XSF
      YG(i) = -YSF
      XSRD(i) = XSR - XSF
      YSRD(i) = YSR - YSF
      XFFD(i) = XFF - XSF
      YFFD(i) = YFF - YSF
      XFRD(i) = XFR - XSF
      YFRD(i) = YFR - YSF
    Next i

    LEGPOS = -4
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of robot"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -10.0 ' Minimum values of axes
    XMAXPLOT = 180 : YMAXPLOT = 10.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_G@,Y_G@ cm" ' Name of axes
    PSCALE() ' Scaling
    NDPLOT = NDPLOTH
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XG(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YG(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '

    X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 8.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -20.0 : YMINPLOT = -10.0 ' Minimum values of axes
    XMAXPLOT = 10 : YMAXPLOT = 10.0 ' Maximum values of axes
    XANAME = "X_G@,X_SR@,X_FF@,X_FR@ cm" : YANAME = "Y_G@,Y_SR@,Y_FF@,Y_FR@ cm" ' Name of axes
    PSCALE() ' Scaling
    NDPLOT = NDPLOTH
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XG(i)
      YPLOT(i) = YG(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XSRD(i)
      YPLOT(i) = YSRD(i)
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XFFD(i)
      YPLOT(i) = YFFD(i)
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XFRD(i)
      YPLOT(i) = YFRD(i)
    Next i
    NUMPEN = 4
    SLINE(graph)
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of leg tip"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -12.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 12.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_F@,X_R@ cm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XJ(i, 4)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XJ(i, 8)
    Next i
    NUMPEN = 2
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -12.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 12.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y_F@,Y_R@ cm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YJ(i, 4)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YJ(i, 8)
    Next i
    NUMPEN = 2
    SLINE(graph)
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Trajectory of leg tip"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -12.0 : YMINPLOT = -12.0 ' Minimum values of axes
    XMAXPLOT = 12.0 : YMAXPLOT = 12.0 ' Maximum values of axes
    XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 4)
      YPLOT(i) = YJ(i, 4)
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 8)
      YPLOT(i) = YJ(i, 8)
    Next i
    NUMPEN = 2
    SLINE(graph)
    '
    GoTo PEND

PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -12.0 : YMINPLOT = -12.0 ' Minimum values of axes
    XMAXPLOT = 12.0 : YMAXPLOT = 12.0 ' Maximum values of axes
    XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 4)
      YPLOT(i) = YJ(i, 4)
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 8)
      YPLOT(i) = YJ(i, 8)
    Next i
    NUMPEN = 2
    SLINE(graph)
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 20
      LPC = k
      Legplot()
    Next k
    '
    GoTo PEND
    '
PAGE5:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -12.0 : YMINPLOT = -12.0 ' Minimum values of axes
    XMAXPLOT = 12.0 : YMAXPLOT = 12.0 ' Maximum values of axes
    XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 4)
      YPLOT(i) = YJ(i, 4)
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 8)
      YPLOT(i) = YJ(i, 8)
    Next i
    NUMPEN = 2
    SLINE(graph)
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    LPC = LEGPOS
    Legplot()
    '
    PXSYMBOL = 15.0 : PYSYMBOL = 16.5
    SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
    PSYMBOL(graph)
    '
    GoTo PEND
    '
PAGE6:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
      XMINPLOT = -12.0 : YMINPLOT = -12.0 ' Minimum values of axes
      XMAXPLOT = 12.0 : YMAXPLOT = 12.0 ' Maximum values of axes
      XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      GAXES(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XJ(i, 4)
        YPLOT(i) = YJ(i, 4)
      Next i
      NUMPEN = 1
      SLINE(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XJ(i, 8)
        YPLOT(i) = YJ(i, 8)
      Next i
      NUMPEN = 2
      SLINE(graph)
      '
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE7:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
      XMINPLOT = -12.0 : YMINPLOT = -12.0 ' Minimum values of axes
      XMAXPLOT = 12.0 : YMAXPLOT = 12.0 ' Maximum values of axes
      XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      GAXES(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XJ(i, 4)
        YPLOT(i) = YJ(i, 4)
      Next i
      NUMPEN = 1
      SLINE(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XJ(i, 8)
        YPLOT(i) = YJ(i, 8)
      Next i
      NUMPEN = 2
      SLINE(graph)
      '
      BLINKCOLOR = 3
      MLINKCOLOR = 6
      JOINTCOLOR = 3
      LPC = k + 180
      If LPC >= 361 Then LPC = LPC - 360
      Legplot()
      '
      BLINKCOLOR = 1
      MLINKCOLOR = 4
      JOINTCOLOR = 2
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Legplot()
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 3
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = XJ(LPC, 1)
    YPLOT(2) = YJ(LPC, 1)
    XPLOT(3) = XJ(LPC, 2)
    YPLOT(3) = YJ(LPC, 2)
    NUMPEN = 7
    DCPLOT(graph)
    NUMPEN = BLINKCOLOR
    '
    NDPOLYGON = 4
    XPOLYGON(1) = XJ(LPC, 2)
    YPOLYGON(1) = YJ(LPC, 2)
    XPOLYGON(2) = XJ(LPC, 5)
    YPOLYGON(2) = YJ(LPC, 5)
    XPOLYGON(3) = XJ(LPC, 3)
    YPOLYGON(3) = YJ(LPC, 3)
    XPOLYGON(4) = XJ(LPC, 4)
    YPOLYGON(4) = YJ(LPC, 4)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = XJ(LPC, 3)
    YPLOT(2) = YJ(LPC, 3)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 5)
    YPLOT(1) = YJ(LPC, 5)
    XPLOT(2) = XJ(LPC, 6)
    YPLOT(2) = YJ(LPC, 6)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 6)
    YPOLYGON(1) = YJ(LPC, 6)
    XPOLYGON(2) = XJ(LPC, 7)
    YPOLYGON(2) = YJ(LPC, 7)
    XPOLYGON(3) = XJ(LPC, 8)
    YPOLYGON(3) = YJ(LPC, 8)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 7
    XPLOT(1) = XJ(LPC, 2)
    YPLOT(1) = YJ(LPC, 2)
    XPLOT(2) = XJ(LPC, 3)
    YPLOT(2) = YJ(LPC, 3)
    XPLOT(3) = XJ(LPC, 4)
    YPLOT(3) = YJ(LPC, 4)
    XPLOT(4) = XJ(LPC, 5)
    YPLOT(4) = YJ(LPC, 5)
    XPLOT(5) = XJ(LPC, 6)
    YPLOT(5) = YJ(LPC, 6)
    XPLOT(6) = XJ(LPC, 7)
    YPLOT(6) = YJ(LPC, 7)
    XPLOT(7) = XJ(LPC, 8)
    YPLOT(7) = YJ(LPC, 8)
    NUMPEN = JOINTCOLOR
    CPLOT(graph)
    '
    NUMPEN = 7
    NDPLOT = 1
    XPLOT(1) = XJ(LPC, 7)
    YPLOT(1) = YJ(LPC, 7)
    DCPLOT(graph)
    NUMPEN = BLINKCOLOR
    '
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Kinematic Analysis of Quad Legged Walking Machine"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0 : PYSYMBOL = 16.5
    SYMBOL = " with 1 DOF by RPMQUADLEG.BAS"
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    P_INITIALIZE()
    P_page = 5
    LEGPOS = LEGPOS + 5
    If LEGPOS >= 361 Then LEGPOS = 1
    Exe()
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = 5
    LEGPOS = LEGPOS - 5
    If LEGPOS <= 0 Then LEGPOS = 361
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub
  Private Sub Trajectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Trajectory.Click
    P_INITIALIZE()
    P_page = P_page + 1
    If P_page >= 5 Then P_page = 1
    Exe()
  End Sub

  Private Sub Movie2L_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Movie2L.Click
    P_INITIALIZE()
    P_page = 6
    Exe()
  End Sub

  Private Sub Movie4L_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Movie4L.Click
    P_INITIALIZE()
    P_page = 7
    Exe()
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
