﻿Public Class RPsynthepg3
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PSYNTHEPG3.C
  '
  '            < RPSYNTHEPG3.BAS >
  '
  '       2011.10.11   CREATED BY N. IWASTUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 2 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim XP(3), YP(3), PHIP(3) As Double ' Precision output
  Dim X1P(3), Y1P(3), X2P(3), Y2P(3) As Double
  Dim THE(362), PHI(362), X4(362), Y4(362) As Double
  Dim X(5), Y(5) As Double
  Dim L(4) As Double
  Dim GSI, ETA, LC, RC
  Dim MINV As Integer
  Dim NDMAX, NDSTORE As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i, k As Integer
    Dim X1, X2, Y1, Y2 As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    '
PAGE1:
    FileOpen(1, "../../../PSYNTHEPG3.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, GSI) : Input(1, ETA) : Input(1, LC)
    RC = Math.Sqrt(GSI * GSI + ETA * ETA)
    For i = 0 To 2 Step 1
      Input(1, XP(i)) : Input(1, YP(i)) : Input(1, PHIP(i))
    Next i
    For i = 0 To 2 Step 1
      Input(1, X1P(i)) : Input(1, Y1P(i)) : Input(1, X2P(i)) : Input(1, Y2P(i))
    Next i
    For i = 0 To 3 Step 1
      Input(1, L(i))
    Next i
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, X(3)) : Input(1, Y(3))
    Input(1, MINV)
    NDMAX = 361
    For i = 1 To NDMAX Step 1
      Input(1, THE(i)) : Input(1, PHI(i)) : Input(1, X4(i)) : Input(1, Y4(i))
      If THE(i) < -360.0 Then GoTo REND
    Next i
REND:
    '
    FileClose(1)
    NDSTORE = i - 1
    NDPLOT = NDSTORE
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.2 : PYSYMBOL = 15.5
    SYMBOL = "Output angle"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 20.0 : YFPLOT = 15.0 ' Final position of axes
    NXPLOT = 8 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 3.0 : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = X4(i)
      YPLOT(i) = Y4(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    NDPLOT = 3
    For i = 1 To 3 Step 1
      XPLOT(i) = XP(i - 1)
      YPLOT(i) = YP(i - 1)
    Next i
    CPLOT(graph)
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.2 : PYSYMBOL = 15.5
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 20.0 : YFPLOT = 15.0 ' Final position of axes
    NXPLOT = 8 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 3.0 : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    PSCALE() ' Scaling
    NDPLOT = NDSTORE
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = X4(i)
      YPLOT(i) = Y4(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For k = 1 To NDSTORE Step 5
      X1 = L(1) * Math.Cos(THE(k) * DR) + X(0)
      Y1 = L(1) * Math.Sin(THE(k) * DR) + Y(0)
      X2 = L(3) * Math.Cos(PHI(k) * DR) + X(3)
      Y2 = L(3) * Math.Sin(PHI(k) * DR) + Y(3)
      '
      NDPLOT = 4
      XPLOT(1) = X(0)
      YPLOT(1) = Y(0)
      XPLOT(2) = X1
      YPLOT(2) = Y1
      XPLOT(3) = X2
      YPLOT(3) = Y2
      XPLOT(4) = X(3)
      YPLOT(4) = Y(3)
      NUMPEN = 1
      SLINE(graph)
      '
      NDPLOT = 2
      XPLOT(1) = X1
      YPLOT(1) = Y1
      XPLOT(2) = X2
      YPLOT(2) = Y2
      NUMPEN = 1
      CPLOT(graph)
      '
      NDPLOT = 2
      XPLOT(1) = X(0)
      YPLOT(1) = Y(0)
      XPLOT(2) = X(3)
      YPLOT(2) = Y(3)
      NUMPEN = 7
      DCPLOT(graph)
    Next k
    '
    k = NDSTORE
    X1 = L(1) * Math.Cos(THE(k) * DR) + X(0)
    Y1 = L(1) * Math.Sin(THE(k) * DR) + Y(0)
    X2 = L(3) * Math.Cos(PHI(k) * DR) + X(3)
    Y2 = L(3) * Math.Sin(PHI(k) * DR) + Y(3)
    '
    NDPLOT = 4
    XPLOT(1) = X(0)
    YPLOT(1) = Y(0)
    XPLOT(2) = X1
    YPLOT(2) = Y1
    XPLOT(3) = X2
    YPLOT(3) = Y2
    XPLOT(4) = X(3)
    YPLOT(4) = Y(3)
    NUMPEN = 1
    SLINE(graph)
    '
    NDPLOT = 4
    XPLOT(1) = X(0)
    YPLOT(1) = Y(0)
    XPLOT(2) = X1
    YPLOT(2) = Y1
    XPLOT(3) = X2
    YPLOT(3) = Y2
    XPLOT(4) = X(3)
    YPLOT(4) = Y(3)
    NUMPEN = 1
    CPLOT(graph)

    For k = 0 To 2 Step 1
      X1 = X1P(k)
      Y1 = Y1P(k)
      X2 = X2P(k)
      Y2 = Y2P(k)
      '
      NDPLOT = 4
      XPLOT(1) = X(0)
      YPLOT(1) = Y(0)
      XPLOT(2) = X1
      YPLOT(2) = Y1
      XPLOT(3) = X2
      YPLOT(3) = Y2
      XPLOT(4) = X(3)
      YPLOT(4) = Y(3)
      NUMPEN = 2
      SLINE(graph)
      '
      NDPLOT = 3
      XPLOT(1) = X1
      YPLOT(1) = Y1
      XPLOT(2) = XP(k)
      YPLOT(2) = YP(k)
      XPLOT(3) = X2
      YPLOT(3) = Y2
      NUMPEN = 2
      SLINE(graph)
      '
      NDPLOT = 5
      XPLOT(1) = X(0)
      YPLOT(1) = Y(0)
      XPLOT(2) = X1
      YPLOT(2) = Y1
      XPLOT(3) = X2
      YPLOT(3) = Y2
      XPLOT(4) = X(3)
      YPLOT(4) = Y(3)
      XPLOT(5) = XP(k)
      YPLOT(5) = YP(k)
      NUMPEN = 2
      CPLOT(graph)
      '
    Next k
    '
    NDPLOT = 2
    XPLOT(1) = X(0)
    YPLOT(1) = Y(0)
    XPLOT(2) = X(3)
    YPLOT(2) = Y(3)
    NUMPEN = 7
    DCPLOT(graph)
    '
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Synthesis of Planar 4-Bar Linkage Path Generator"
    PSYMBOL(graph)
    '
    PXSYMBOL = 8.0 : PYSYMBOL = 16.5
    SYMBOL = "by RPSYNTHEPG3.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 0.4 : PYSYMBOL = 16.0
    SYMBOL = "L_0@=" + Str$(L(0)) + ", L_1@=" + Str$(L(1)) + ", L_2@=" + Str$(L(2)) + ", L_3@=" + Str$(L(3)) + " [m]"
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
