//------------------------------------------------
// 
//      RRxJwbh
//          ̓vbgtH[̉^vZ
//         i֐ŋ쓮j
//
//          < EE3DCH.CPP >
//
//  A_amp, A_phase, A_period :
//                   vbgtH[̊p^w
//                   (֐쓮)
//  time           : 
//  A              : vbgtH[̊p^
//
//     2010. 8.21  쐬 BY ╍
//     2018. 4.18   BY ╍
//
//------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"

void EE3DCH( double time, 
		     VECTOR3 A_amp, VECTOR3 A_phase, VECTOR3 A_period,
             POSTURE *A
)
{

	double r, rt;                            // Ǝ   

	r = PAI2/A_period.x;   
	rt = r*time;
	A->RPY.x = A_amp.x*sin( rt + A_phase.x );
	A->DRPY.x = r*A_amp.x*cos( rt + A_phase.x );
	A->DDRPY.x = -r*r*A_amp.x*sin( rt + A_phase.x );
	r = PAI2/A_period.y;   
	rt = r*time;
	A->RPY.y = A_amp.y*sin( rt + A_phase.y );
	A->DRPY.y = r*A_amp.y*cos( rt + A_phase.y );
	A->DDRPY.y = -r*r*A_amp.y*sin( rt + A_phase.y );
	r = PAI2/A_period.z;   
	rt = r*time;
	A->RPY.z = A_amp.z*sin( rt + A_phase.z );
	A->DRPY.z = r*A_amp.z*cos( rt + A_phase.z );
	A->DDRPY.z = -r*r*A_amp.z*sin( rt + A_phase.z );
}
