//----------------------------------------------------------
//  
//      URxԃp}js[^ 
//        (X`[gvbgtH[j
//                ̋t^w
//
//           < PIKSTEWARTP.CPP >
//
//   RU[6], PSIU[6] : vbgtH[̋΋ʒu
//   ZU[6]            iWnC~Wj
//   RL[6], PSIL[6] : Î~vbgtH[̋΋ʒu
//   ZL[6]            iÎ~WnC~Wj
//   THE0[6]        : Î~΋􂩂璼i΋܂ł̋
//   PJUM[6]        : vbgtH[̋΋ʒu
//                   iWnCWj
//   PJLF[6]        : Î~vbgtH[̋΋ʒu
//                    (Î~WnCWj
//   op_time        : 쓮
//   P_start, P_final, P_delta :
//                    vbgtH[̕i^w
//                    (T◯֐쓮)
//   A_start, A_final, A_delta :
//                    vbgtH[̊p^w
//                    (T◯֐쓮)
//   time           : 
//   P              : vbgtH[̕i^
//   A              : vbgtH[̊p^
//   TT[3][3], dTT[3][3], ddTT[3][3] :
//                    vbgtH[̍Wϊsi]uj
//                    Ƃ̔
//   OMG            : vbgtH[̊pxEpx
//   PJUF[6]        : vbgtH[̋΋ʒu
//                   iÎ~WnCWj
//   THE[6]         : AN`G[^͂Ƃ̔
//
//     ** KvȃTuvO **
//           DRMSTEWARTP
//           DRESTEWARTP
//           EESTEWARTP
//           IKSTEWARTP
//
//     ** Kvȃf[^t@C **
//           IMDATA.DAT  (DRMSTEWARTP)
//
//     ** o̓f[^t@C **
//           PIKSTEWARTP.DAT
//           PIKSTEWARTP.CSV
//
//     2007.12.11  CREATED BY N. IWATSUKI
//     2008. 1.21 IMPROVED BY N. IWATSUKI
//     2010. 8.21 IMPROVED BY N. IWATSUKI
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"
#include "matrix.h"
#include "PikStewartP_subfunctions.h"
			
void main(void)
{

//---- ϐ̐錾 ----

	POSITION P;
	POSTURE A;
	AVELOCITY OMG;

	POSITION PJUM[6];
	POSITION PJLF[6], PJUF[6];
	POSITION PJPF[6];
	VECTOR3 P_start, P_final, P_delta;
	VECTOR3 A_start, A_final, A_delta;
	VARIABLE THE[6];

	double RL[6], PSIL[6], ZL[6], RU[6], PSIU[6], ZU[6];
	double THE0[6];
	double TT[3][3], dTT[3][3], ddTT[3][3];

    double op_time;
	double time;		       // 
	char name[100];            // w

	FILE *fpDAT, *fpCSV;       // t@C|C^

	int i,j;                   // ƕϐ
	int ier;                   // G[CWP[^

//---- f[^ ----

	printf("** ́F");
	gets_s(name);

	DRMSTEWARTP( RU, PSIU, ZU, RL, PSIL, ZL, THE0, PJUM, PJLF );    // @\萔̓ǂݍ

	DRESTEWARTP( &op_time, 
		         &P_start, &P_final, &P_delta,
			     &A_start, &A_final, &A_delta );              // vbgtH[̉^ݒ

//---- ̏o -----

	if( fopen_s( &fpDAT, "PIKSTEWARTP.DAT","wt") != SUCCESS ){
		printf("++ G[ : t@CPIKSTEWARTPF.DATJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PIKSTEWARTPF.CSV","wt") != SUCCESS ){
		printf("++ G[ : t@CPIKSTEWARTPF.CSVJ܂I\n");
		exit(0);
	}

	fprintf(fpDAT, "by %s\n", name);
	fprintf(fpDAT, "BY PIKSTEWARTP.CPP\n");

	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", RL[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", PSIL[i]*RD );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", ZL[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", RU[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", PSIU[i]*RD );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", ZU[i] );
	}
	fprintf( fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", THE0[i] );
	}
	fprintf( fpDAT, "\n");
	fprintf( fpDAT, "%13.5f\n", op_time);
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", P_start.x, P_start.y, P_start.z );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", A_start.x*RD , A_start.y*RD , A_start.z*RD  );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", P_final.x, P_final.y, P_final.z );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", A_final.x*RD , A_final.y*RD , A_final.z*RD  );

	fprintf(fpCSV, "%s\n", name);
	fprintf(fpCSV,
		"TIME, X, dX, ddX, Y, dY, ddY, Z, dZ, ddZZ, ");
	fprintf(fpCSV,
		"Roll, dRoll, ddRoll, Pitch, dPitch, ddPitch, Yaw, dYaw, ddYaw, ");
	fprintf(fpCSV,
		"Omgx, dOmgx, Omgy, dOmgy, Omgz, dOmgz, ");
	fprintf(fpCSV,
		"THE1, dTHE1, ddTHE1, THE2, dTHE2, ddTHE2, THE3, dTHE3, ddTHE3, ");
	fprintf(fpCSV,
		"THE4, dTHE4, ddTHE4, THE5, dTHE5, ddTHE5, THE6, dTHE6, ddTHE6 \n");

//---- C[v -----

	for(j=0; j<=500; j++){

		time = ( (double)j)*op_time/500.0;                        // 

        EESTEWARTP ( op_time, time, 
			    P_start, P_final, P_delta, A_start, A_final, A_delta,
			    &P, &A );                                         // vbgtH[̉^vZ

		ier = IKSTEWARTP ( PJUM, PJLF, 
						   THE0,
					       P, A, 
					       TT, dTT, ddTT, 
					       &OMG, 
					       PJUF, PJPF, 
						   THE );                                      // t^wvZ
		if( ier != SUCCESS ) {
			printf("++ Error in IKSTEWART iَpłj\n");
			exit( 0 );
		}
		printf("%7.4f", time );
		printf("%11.4f %11.4f %11.4f", P.P.x, P.P.y, P.P.z );
		printf("%11.4f %11.4f %11.4f", A.RPY.x*RD, A.RPY.y*RD, A.RPY.z*RD );
		printf("\n");

		fprintf(fpDAT, "%7.4f", time );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", P.P.x, P.DP.x, P.DDP.x );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", P.P.y, P.DP.y, P.DDP.y );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", P.P.z, P.DP.z, P.DDP.z );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.x*RD, A.DRPY.x*RD, A.DDRPY.x*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.y*RD, A.DRPY.y*RD, A.DDRPY.y*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.z*RD, A.DRPY.z*RD, A.DDRPY.z*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f %13.6f %13.6f %13.6f", OMG.OMG.x*RD, OMG.DOMG.x*RD, OMG.OMG.y*RD, OMG.DOMG.y*RD, OMG.OMG.z*RD, OMG.DOMG.z*RD);
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[0].v, THE[0].dv, THE[0].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[1].v, THE[1].dv, THE[1].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[2].v, THE[2].dv, THE[2].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[3].v, THE[3].dv, THE[3].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[4].v, THE[4].dv, THE[4].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[5].v, THE[5].dv, THE[5].ddv );
		fprintf(fpDAT, "\n" );
		fprintf(fpCSV, "%7.4f,", time );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", P.P.x, P.DP.x, P.DDP.x );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", P.P.y, P.DP.y, P.DDP.y );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", P.P.z, P.DP.z, P.DDP.z );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.x*RD, A.DRPY.x*RD, A.DDRPY.x*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.y*RD, A.DRPY.y*RD, A.DDRPY.y*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.z*RD, A.DRPY.z*RD, A.DDRPY.z*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f, %13.6f, %13.6f, %13.6f,", OMG.OMG.x*RD, OMG.DOMG.x*RD, OMG.OMG.y*RD, OMG.DOMG.y*RD, OMG.OMG.z*RD, OMG.DOMG.z*RD);
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[0].v, THE[0].dv, THE[0].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[1].v, THE[1].dv, THE[1].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[2].v, THE[2].dv, THE[2].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[3].v, THE[3].dv, THE[3].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[4].v, THE[4].dv, THE[4].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f", THE[5].v, THE[5].dv, THE[5].ddv );
		fprintf(fpCSV, "\n" );
	}
	fclose(fpDAT);                //@t@CN[Y
	fclose(fpCSV);                //@t@CN[Y 
}
