//----------------------------------------------------------
//  
//      URxԃp}js[^ 
//        (X`[gvbgtH[j
//                ̍Ɨ̈
//         (vbgtH[iꍇ,
//          AN`G[^̉^Ƌ΋̌X
//          ɂƗ̈)
//
//           < PWSSTEWARTP.CPP >
//
//   RU[6], PSIU[6] : vbgtH[̋΋ʒu
//   ZU[6]            iWnC~Wj
//   RL[6], PSIL[6] : Î~vbgtH[̋΋ʒu
//   ZL[6]            iÎ~WnC~Wj
//   THE0[6]        : Î~΋􂩂璼i΋܂ł̋
//   PJUM[6]        : vbgtH[̋΋ʒu
//                   iWnCWj
//   PJLF[6]        : Î~vbgtH[̋΋ʒu
//                    (Î~WnCWj
//   XMIN, XMAX, DX : XT
//   YMIN, YMAX, DY : YT
//   ZMIN, ZMAX, DZ : ZT
//   LMIN, LMAX     : AN`G[^̐
//   PHIMAX         : ΋̌X;
//   P              : vbgtH[̕i^
//   A              : vbgtH[̊p^
//   TT[3][3], dTT[3][3], ddTT[3][3] :
//                    vbgtH[̍Wϊsi]uj
//                    Ƃ̔
//   OMG            : vbgtH[̊pxEpx
//   PJUF[6]        : vbgtH[̋΋ʒu
//                   iÎ~WnCWj
//   THE[6]         : AN`G[^͂Ƃ̔
//
//     ** KvȃTuvO **
//           DRMSTEWARTP
//           IKSTEWARTP
//
//     ** o̓f[^t@C **
//           PWSSTEWARTP.DAT
//           PWSSTEWARTP.CSV
//
//     2010. 8.22 쐬 BY ╍
//     2018. 4.19  BY ╍
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"
#include "matrix.h"
#include "PwsStewartP_subfunctions.h"
			
void main(void)
{

//---- ϐ̐錾 ----

	POSITION P;
	POSTURE A;
	AVELOCITY OMG;

	POSITION PJUM[6];
	POSITION PJLF[6], PJUF[6];
	POSITION PJPF[6];
	VARIABLE THE[6];

	double RL[6], PSIL[6], ZL[6], RU[6], PSIU[6], ZU[6];
	double THE0[6];
	double TT[3][3], dTT[3][3], ddTT[3][3];

	double XMIN, XMAX, DX;     // XT
	double YMIN, YMAX, DY;     // YT
	double ZMIN, ZMAX, DZ;     // ZT
	double LMIN, LMAX;         // AN`G[^̐
	double PHIMAX;             // ΋̌X;
	double dex, dey, dez, dd;
	double ACTANG;

	int NX, NY, NZ;            // T\

	char name[100];            // w
	double tmpf[100];

	int i, ix, iy, iz;                   // ƕϐ
	int ier;                   // G[CWP[^
	int icount;

	FILE *fpDAT, *fpCSV;       // t@C|C^

//---- f[^ ----

	printf("** ́F");
	gets_s(name);

	DRMSTEWARTP( RU, PSIU, ZU, RL, PSIL, ZL, THE0, PJUM, PJLF );    // @\萔̓ǂݍ

	printf( "** X̒T͈Xmin,Xmax,\dX[m]:");
	finput_val( tmpf, 3 );
	XMIN = tmpf[0];
	XMAX = tmpf[1];
	DX = tmpf[2];
	printf( "** Y̒T͈Ymin,Ymax,\dY[m]:");
	finput_val( tmpf, 3 );
	YMIN = tmpf[0];
	YMAX = tmpf[1];
	DY = tmpf[2];
	printf( "** Z̒T͈Zmin,Zmax,\dZ[m]:");
	finput_val( tmpf, 3 );
	ZMIN = tmpf[0];
	ZMAX = tmpf[1];
	DZ = tmpf[2];
	printf( "** AN`G[^̐Lmin,Lmax[m]:");
	finput_val( tmpf, 2 );
	LMIN = tmpf[0];
	LMAX = tmpf[1];
	printf( "** ΋̌XpxPhimax[deg]:");
	finput_val( tmpf, 1 );
	PHIMAX = tmpf[0]*DR;

//---- ̏o -----

	if( fopen_s( &fpDAT, "PWSSTEWARTP.DAT","wt") != SUCCESS ){
		printf("++ G[ : t@CPWSSTEWARTPF.DATJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PWSSTEWARTPF.CSV","wt") != SUCCESS ){
		printf("++ G[ : t@CPWSSTEWARTPF.CSVJ܂I\n");
		exit(0);
	}

	fprintf(fpDAT, "by %s\n", name);
	fprintf(fpDAT, "BY PWSSTEWARTP.CPP\n");

	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", RL[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", PSIL[i]*RD );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", ZL[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", RU[i] );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", PSIU[i]*RD );
	}
	fprintf(fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", ZU[i] );
	}
	fprintf( fpDAT, "\n");
	for( i=0; i<6; i++ ){
		fprintf(fpDAT, "%13.5f", THE0[i] );
	}
	fprintf( fpDAT, "\n");
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", XMIN, XMAX, DX );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", YMIN, YMAX, DY  );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", ZMIN, ZMAX, DZ );
	fprintf( fpDAT, "%13.5f %13.5f\n", LMIN, LMAX  );
	fprintf( fpDAT, "%13.5f\n", PHIMAX*RD );

	fprintf(fpCSV, "%s\n", name);
	fprintf(fpCSV,"No, X, Y, Z\n");

	P.DP.x = 0.0;
	P.DP.y = 0.0;
	P.DP.z = 0.0;
	P.DDP.x = 0.0;
	P.DDP.y = 0.0;
	P.DDP.z = 0.0;

	A.RPY.x = 0.0;
	A.RPY.y = 0.0;
	A.RPY.z = 0.0;
	A.DRPY.x = 0.0;
	A.DRPY.y = 0.0;
	A.DRPY.z = 0.0;
	A.DDRPY.x = 0.0;
	A.DDRPY.y = 0.0;
	A.DDRPY.z = 0.0;

//---- C[v -----

	icount = 0;

	NX = (int)( ( XMAX - XMIN )/DX );
	NY = (int)( ( YMAX - YMIN )/DY );
	NZ = (int)( ( ZMAX - ZMIN )/DZ );
 
	for(ix=0;ix<NX;ix++) {
		P.P.x = ( (double)ix )*DX + XMIN; 				
		for(iy=0;iy<NY;iy++) {
			P.P.y = ( (double)iy )*DY + YMIN; 				
			for(iz=0;iz<NZ;iz++) {
				P.P.z = ( (double)iz )*DZ + ZMIN; 				
				ier = IKSTEWARTP ( PJUM, PJLF, 
						   THE0,
					       P, A, 
					       TT, dTT, ddTT, 
					       &OMG, 
					       PJUF, PJPF, 
						   THE );                                      // t^wvZ
				for(i=0;i<6;i++) {
					if( THE[i].v<LMIN || THE[i].v>LMAX )  {
						ier = ERROR;
						break;
					}
				}
				for(i=0;i<6;i++) {
					dex = PJUF[i].P.x - PJLF[i].P.x;
					dey = PJUF[i].P.y - PJLF[i].P.y;
					dez = PJUF[i].P.z - PJLF[i].P.z;
					dd = sqrt( dex*dex + dey*dey + dez*dez );
					ACTANG = acos( dez/dd );
					if( ACTANG>PHIMAX ) {
						ier = ERROR;
						break;
					}
				}
				if( ier != ERROR ) {
					icount++;
					fprintf(fpDAT, "%7d %13.6f %13.6f %13.6f\n", icount, P.P.x, P.P.y, P.P.z );
					fprintf(fpCSV, "%7d, %13.6f, %13.6f, %13.6f\n", icount, P.P.x, P.P.y, P.P.z );
				}
			}
		}
	}
	icount = -1;
	fprintf(fpDAT, "%7d %13.6f %13.6f %13.6f", icount, P.P.x, P.P.y, P.P.z );
	fprintf(fpCSV, "%7d, %13.6f, %13.6f, %13.6f\n", icount, P.P.x, P.P.y, P.P.z );

	fclose(fpDAT);                //@t@CN[Y
	fclose(fpCSV);                //@t@CN[Y 
}
