//-----------------------------------------------------
//   
//  @@ i΋o͕ʂU߃N@\̋t͊w
//
//             < idp6barpo.cpp >
//
//   J[7]     : ΋̈ʒuExEx
//   CG[5]    : ߂̏dS̈ʒuExEx
//   phig[5]  : ߂̎ppEpxEpx
//   fex      : O
//
//   fjx[7], fjy[7] : 
//              ΋p
//   tauj6    : o͐߂̑΋p[g
//   taui     : 쓮gN 
//
//     ** KvTuvO **
//           gauss
//
//      2008. 2.14 쐬 BY ╍
//      2011.10.10  BY ╍
//
//-----------------------------------------------------

#include <stdio.h> 
#include <stdlib.h>
#include "mech.h"
#include "math.h"
#include "Pidp6barpo_subfunctions.h"

int IDP6BARPO( double M[], double I[], 
		   POINT J[], ANGLE psi, POINT CG[], ANGLE phig[], double fe,
		   double fjx[], double fjy[], double *tauj6, double *taui )
{
    double  wa[NV][NV], wb[NV], wk[NV];
	int     ipw[NV];
	int     ichk;
	int     i, j;
    double  cp, sp;
	double  Grav;

	Grav = -9.805;

    for(j=0;j<NV;j++)  {
		for(i=0;i<NV;i++) {
            wa[i][j] = 0.0;
		}
	}

	cp = cos( psi.the );
	sp = sin( psi.the );

//----- Ws̐ݒ ------

    wa[ 0][ 0] =  1.0;
    wa[ 0][ 2] =  1.0;

    wa[ 1][ 1] =  1.0;
    wa[ 1][ 3] =  1.0;

    wa[ 2][ 0] =  CG[0].P.y - J[0].P.y;
    wa[ 2][ 1] =  J[0].P.x - CG[0].P.x;
    wa[ 2][ 2] =  CG[0].P.y - J[1].P.y;
    wa[ 2][ 3] =  J[1].P.x - CG[0].P.x;
    wa[ 2][14] =  1.0;

    wa[ 3][ 2] = -1.0;
    wa[ 3][ 4] =  1.0;
    wa[ 3][ 8] =  1.0;

    wa[ 4][ 3] = -1.0;
    wa[ 4][ 5] =  1.0;
    wa[ 4][ 9] =  1.0;

    wa[ 5][ 2] =  J[1].P.y - CG[1].P.y;
    wa[ 5][ 3] =  CG[1].P.x - J[1].P.x;
    wa[ 5][ 4] =  CG[1].P.y - J[2].P.y;
    wa[ 5][ 5] =  J[2].P.x - CG[1].P.x;
    wa[ 5][ 8] =  CG[1].P.y - J[4].P.y;
    wa[ 5][ 9] =  J[4].P.x - CG[1].P.x;

    wa[ 6][ 4] = -1.0;
    wa[ 6][ 6] =  1.0;

    wa[ 7][ 5] = -1.0;
    wa[ 7][ 7] =  1.0;

    wa[ 8][ 4] =  J[2].P.y - CG[2].P.y;
    wa[ 8][ 5] =  CG[2].P.x - J[2].P.x;
    wa[ 8][ 6] =  CG[2].P.y - J[3].P.y;
    wa[ 8][ 7] =  J[3].P.x - CG[2].P.x;

    wa[ 9][ 8] = -1.0;
    wa[ 9][10] =  1.0;

    wa[10][ 9] = -1.0;
    wa[10][11] =  1.0;

    wa[11][ 8] =  J[4].P.y - CG[3].P.y;
    wa[11][ 9] =  CG[3].P.x - J[4].P.x;
    wa[11][10] =  CG[3].P.y - J[5].P.y;
    wa[11][11] =  J[5].P.x - CG[3].P.x;

    wa[12][10] = -1.0;
    wa[12][12] =  sp;

    wa[13][11] = -1.0;
    wa[13][12] = -cp;

    wa[14][10] =  J[5].P.y - CG[4].P.y;
    wa[14][11] =  CG[4].P.x - J[5].P.x;
    wa[14][12] =  ( CG[4].P.y - J[6].P.y )*cp + ( CG[4].P.x - J[6].P.x )*sp;
    wa[14][13] =  1.0;

//----- 萔xNg̐ݒ ------

    wb[ 0] = M[0]*CG[0].DDP.x;
    wb[ 1] = M[0]*( CG[0].DDP.y - Grav );
    wb[ 2] = I[0]*phig[0].ddthe;
    wb[ 3] = M[1]*CG[1].DDP.x;
    wb[ 4] = M[1]*( CG[1].DDP.y - Grav );
    wb[ 5] = I[1]*phig[1].ddthe;
    wb[ 6] = M[2]*CG[2].DDP.x;
    wb[ 7] = M[2]*( CG[2].DDP.y - Grav );
    wb[ 8] = I[2]*phig[2].ddthe;
    wb[ 9] = M[3]*CG[3].DDP.x;
    wb[10] = M[3]*( CG[3].DDP.y - Grav );
    wb[11] = I[3]*phig[3].ddthe;
    wb[12] = M[4]*CG[4].DDP.x + fe*cp;
    wb[13] = M[4]*( CG[4].DDP.y - Grav ) + fe*sp;
    wb[14] = I[4]*phig[4].ddthe - ( J[6].P.y - CG[4].DDP.y )*fe*cp + ( J[6].P.x - CG[4].DDP.x )*sp;

//----- KEX|W_@ɂAP̉ -----

	ichk = GAUSS( wa, wb, ipw, wk );
    if( ichk != 1 )  return ( ichk );

//----- t͊w̏o -----

    fjx[0] = wb[ 0];
    fjy[0] = wb[ 1];
    fjx[1] = wb[ 2];
    fjy[1] = wb[ 3];
    fjx[2] = wb[ 4];
    fjy[2] = wb[ 5];
    fjx[3] = wb[ 6];
    fjy[3] = wb[ 7];
    fjx[4] = wb[ 8];
    fjy[4] = wb[ 9];
    fjx[5] = wb[10];
    fjy[5] = wb[11];
	fjx[6] = fe;
	fjy[6] = wb[12];
	*tauj6 = wb[13];
    *taui =  wb[14];

	return ( SUCCESS );
}
