//----------------------------------------------------------
//
//  @@ i΋o͕ʂU߃N@\̉^w 
//@@@@@ߓ]̏ꍇ 
//
//           < pmp6barpo.cpp >
//
//   L[4]     : ߒ
//   gsi[2], eta[2] :
//              Ԑ߂̕`_̓W
//   PG       : i΋̃KCh̋K_Ƃ̔
//   psi      : i΋̃KCh̎ppƂ̔ 
//   theta    : ߊpψʁEpxEpx
//   J[7]     : ΋̈ʒuExEx
//   s        : o͐ߕψʁExEx
//   ichk     : G[CWP[^
//                 ichk = 991 : QAJ3J2J1\łȂ
//                 ichk = 992 : QAJ4J5J6\łȂ
//
//     ** KvTuvO **
//           DRMP6BARPO
//           MP6BARPO
//
//     ** ̓f[^t@C **
//           IMDATA.dat (DRMP6BARPO)
//
//     ** o̓f[^t@C **
//           PMP6BARPO.dat
//           PMP6BARPO.csv
//           PMP6BARPO.trj
//
//     2002. 3.22 쐬 BY ╍
//     2011.10. 9  BY ╍
//     2018. 4.19  BY ╍
//
//-----------------------------------------------------------

#include <stdio.h> 
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"
#include "pmp6barpo_subfunctions.h"

void main(void)
{
	double L[4];			// ߒ
	double gsi[2], eta[2];	// Ԑߕ`_̓W
	ANGLE theta;			// ߊpψʁEpxEp
	POINT PG;               // i΋̃KCh̋K_Ƃ̔
    ANGLE psi;              // i΋̃KCh̎ppƂ̔ 
	POINT J[7];				// ΋̈ʒuExEx
	VARIABLE s;				// o͐ߕψʁExEx
	double rpm;				// ߉]x
	double th;				// ߊpψ
	char   name[100];	    // vZҎ

	FILE *fpDAT, *fpCSV, *fpTRJ;    // t@C|C^

	int i, ith;             // ƕϐ
	int ichk;               // G[CWP[^
	double tmpf[10];

//------ f[^ ------

	printf("** ́F");
	gets_s(name);
	printf("\n");

    DRMP6BARPO( L, gsi, eta, &PG, &psi, J );
	printf("** ߉]x [RPM]F\n");
	finput_val( tmpf, 1 );
	rpm = tmpf[0];

	theta.dthe = rpm*360/60*DR;
	theta.ddthe = 0;

//------ o̓t@C̃I[v (PMP6BARPO.DAT,PMP6BARPO.CSV,PMP6BARPO.TRJj------

	if( fopen_s( &fpDAT, "PMP6BARPO.DAT","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMP6BARPO.DATJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PMP6BARPO.CSV","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMP6BARPO.CSVJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpTRJ, "PMP6BARPO.TRJ","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMP6BARPO.TRJJ܂I\n");
		exit(0);
	}
//------ ̏o ------

	fprintf(fpDAT, " by %s\n", name);
	fprintf(fpDAT, "with PMP6BARPO.CPP\n");

	fprintf(fpDAT, "%13.5f %13.5f\n", J[0].P.x, J[0].P.y );
	fprintf(fpDAT, "%13.5f %13.5f\n", J[3].P.x, J[3].P.y );
	for( i=0; i<4; i++ ) {
		fprintf(fpDAT, "%13.5f \n", L[i] );
	}
	for( i=0; i<2; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f\n", gsi[i], eta[i] );
	}
	fprintf(fpDAT, "%13.5f %13.5f\n", PG.P.x, PG.P.y );
	fprintf(fpDAT, "%13.5f\n", psi.the*RD );
	fprintf( fpDAT, "%13.5f\n", rpm);

	fprintf(fpCSV, "%s\n", name);
	fprintf( fpCSV, "The,S,dS,ddS,Xp,dXp,ddXp,Yp,dYp,ddYp\n");

//------ C[v ------

	for( ith=0; ith<=360; ith++ ){
		th = (double)ith;
		theta.the = th*DR;
		
		ichk = MP6BARPO( L, gsi, eta, PG, psi, theta, J, &s );
		if( ichk != SUCCESS ) {
			printf( "\n ++ G[ MP6BARPO! ier= %d \n", ichk );
			exit ( 0 );
		}

		fprintf(fpDAT, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f\n",
			    th, s.v, s.dv, s.ddv,
				J[4].P.x, J[4].DP.x, J[4].DDP.x,
				J[4].P.y, J[4].DP.y, J[4].DDP.y
        );
		fprintf(fpCSV, "%7.1f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f\n",
			    th, s.v, s.dv, s.ddv,
				J[4].P.x, J[4].DP.x, J[4].DDP.x,
				J[4].P.y, J[4].DP.y, J[4].DDP.y
        );
		fprintf(fpTRJ, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f\n",
			    th, 
				J[0].P.x, J[0].P.y, J[1].P.x, J[1].P.y, J[2].P.x, J[2].P.y, J[3].P.x, J[3].P.y,
				J[4].P.x, J[4].P.y, J[5].P.x, J[5].P.y, J[6].P.x, J[6].P.y   );
		printf("%7.1f %13.5f %13.5f %13.5f\n", th, s.v, J[4].P.x, J[4].P.y );
	}

	fclose( fpDAT );
	fclose( fpCSV );
    fclose( fpTRJ );
}
