//------------------------------------------------------
//  
//   RRxʂUߒP[vr@\̏^w
//
//          < fkpolleg.cpp >
//
//   J[7]     : ֐߂̈ʒuExEx
//   PHI      : ̎ppEpxEpx
//   theta[3] : ֐ߊpEpxEpx
//   L[6]    : ߒ
//
//     ** KvTuvO **
//          crank_input
//          RRR_links
//          coupler_point
//
//     2023. 4.27 쐬  BY ╍
//
//------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "cal.h"
#include "personalio.h"
#include "mech.h"

int FKPOLLEG( POINT J[], ANGLE *PHI, ANGLE theta[], double L[] )
{
	ANGLE dummy;

	int minv, ichk;

	dummy.the = dummy.dthe = dummy.ddthe = 0.0;

	minv = -1;

	crank_input( J[0], L[0], theta[0], dummy, &J[1] );
	crank_input( J[5], L[4], theta[1], dummy, &J[4] );
	crank_input( J[4], L[3], theta[2], theta[1], &J[3] );

	ichk = RRR_links( J[3], J[1], L[2], L[1], minv, &J[2] );
	if( ichk !=SUCCESS ) return ( ERROR );

    coupler_point( J[3], J[2], L[2]*0.5, 0.0, &J[6] , &dummy );
	link_angle ( J[3], J[2], PHI );

	return ( SUCCESS );
}
