//----------------------------------------------------------
//
//  @@ PRxʃN@\ɂSs@B
//            r@\̉^w͌vZ
//
//           < pmquadleng.cpp >
//
//   L[5]     : ߒ
//   gsi[3], eta[3] :
//              Ԑ߂̕`_̓W
//   theta0   : ߊpψʏl
//   theta    : ߊpψʁEpxEpx
//   J[9]     : ΋̈ʒuExEx
//                 ichk = 0   : G[Ȃ
//                 ichk = 991 : QAJ2J3J1\łȂ
//                 ichk = 992 : QAJ7J6J5\łȂ
//
//     ** KvTuvO **
//           DRMPQUADLEG
//           MPQUADLEGF
//
//     ** ̓f[^t@C **
//           IMDATA.dat (DRMPQUADLEG)
//
//     ** o̓f[^t@C **
//           PMQUADLEG.dat
//           PMQUADLEG.csv
//
//     2015. 5.17 쐬 BY ╍ 
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"
#include "pmquadleg_subfunctions.h"

void main(void)
{
	double L[5];			// ߒ
	double gsi[3], eta[3];	// Ԑߕ`_̓W
	ANGLE theta;			// ߊpψʁEpxEp
	POINT J[9];  			// ΋̈ʒuExEx
	double rpm;				// ߉]x
	double th;				// ߉]p
	double theta0;			// ߊpψʏl
	char   name[100];	    // vZҎ

	FILE *fpDAT, *fpCSV;	// t@C|C^

	int i, ith;             // ƕϐ
	int ichk;               // G[CWP[^
	double tmpf[10];

//------ f[^ ------

	printf("** ́F");
	gets_s(name);
	printf("\n");

	DRMPQUADLEG( L, gsi, eta, &theta0, J );
	printf("** ߉]x [RPM]F\n");
	finput_val( tmpf, 1 );
	rpm = tmpf[0];

	theta.dthe = rpm*360/60*DR;
	theta.ddthe = 0;

//------ o̓t@C̃I[v (PMQUADLEG.DAT,PMQUADLEG.CSV j------

	if( fopen_s( &fpDAT, "PMQUADLEG.DAT","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMPQUADLEG.DATJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PMQUADLEG.CSV","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMPQUADLEG.CSVJ܂I\n");
		exit(0);
	}

//------ ̏o ------

	fprintf(fpDAT, " by %s\n", name);
	fprintf(fpDAT, "with PMPQUADLEG.CPP\n"); 

	for( i=0; i<2; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f\n", J[i].P.x, J[i].P.y );
	}
	fprintf(fpDAT, "%13.5f %13.5f\n", J[ 7].P.x, J[ 7].P.y );
	for( i=0; i<5; i++ ) {
		fprintf(fpDAT, "%13.5f\n", L[i] );
	}
	for( i=0; i<3; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f\n", gsi[i], eta[i] );
	}
	fprintf( fpDAT, "%13.5f\n", theta0*RD );
	fprintf( fpDAT, "%13.5f\n", rpm);
	
	fprintf( fpCSV, "%s\n", name);
	fprintf( fpCSV, "The,PhiH,dPhiH,ddPhiH,PhiK,dPhiK,ddPhiK,PhiA,dPhiA,ddPhiA,XK,dXK,ddXK,YK,dYK,ddYK,XA,dXA,ddXA,YA,dYA,ddYA,XT,dXT,ddXT,YT,dYT,ddYT,Xh,dXh,ddXh,Yh,dYh,ddYh \n");

//------ C[v -------

	for( ith=0; ith<=360; ith++ ){
		th = (double)ith;
		theta.the = th*DR;
		ichk = MPQUADLEG ( L, gsi, eta, theta, theta0, J );
		if( ichk != SUCCESS ) {
			printf( "\n ++ Error in MPQUADLEG! ier= %d \n", ichk );
			exit ( 0 );
		}  
		fprintf(fpDAT, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f	%13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f \n",
			    th, 
				J[0].P.x, J[0].DP.x, J[0].DDP.x, J[0].P.y, J[0].DP.y, J[0].DDP.y,
				J[1].P.x, J[1].DP.x, J[1].DDP.x, J[1].P.y, J[1].DP.y, J[1].DDP.y,
				J[2].P.x, J[2].DP.x, J[2].DDP.x, J[2].P.y, J[2].DP.y, J[2].DDP.y,
				J[3].P.x, J[3].DP.x, J[3].DDP.x, J[3].P.y, J[3].DP.y, J[3].DDP.y,
				J[4].P.x, J[4].DP.x, J[4].DDP.x, J[4].P.y, J[4].DP.y, J[4].DDP.y,
				J[5].P.x, J[5].DP.x, J[5].DDP.x, J[5].P.y, J[5].DP.y, J[5].DDP.y,
				J[6].P.x, J[6].DP.x, J[6].DDP.x, J[6].P.y, J[6].DP.y, J[6].DDP.y,
				J[7].P.x, J[7].DP.x, J[7].DDP.x, J[7].P.y, J[7].DP.y, J[7].DDP.y,
				J[8].P.x, J[8].DP.x, J[8].DDP.x, J[8].P.y, J[8].DP.y, J[8].DDP.y
				);
		fprintf(fpCSV, "%7.1f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f %13.5f, %13.5f, %13.5f %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f \n",
			    th, 
				J[0].P.x, J[0].DP.x, J[0].DDP.x, J[0].P.y, J[0].DP.y, J[0].DDP.y,
				J[1].P.x, J[1].DP.x, J[1].DDP.x, J[1].P.y, J[1].DP.y, J[1].DDP.y,
				J[2].P.x, J[2].DP.x, J[2].DDP.x, J[2].P.y, J[2].DP.y, J[2].DDP.y,
				J[3].P.x, J[3].DP.x, J[3].DDP.x, J[3].P.y, J[3].DP.y, J[3].DDP.y,
				J[4].P.x, J[4].DP.x, J[4].DDP.x, J[4].P.y, J[4].DP.y, J[4].DDP.y,
				J[5].P.x, J[5].DP.x, J[5].DDP.x, J[5].P.y, J[5].DP.y, J[5].DDP.y,
				J[6].P.x, J[6].DP.x, J[6].DDP.x, J[6].P.y, J[6].DP.y, J[6].DDP.y,
				J[7].P.x, J[7].DP.x, J[7].DDP.x, J[7].P.y, J[7].DP.y, J[7].DDP.y,
				J[8].P.x, J[8].DP.x, J[8].DDP.x, J[8].P.y, J[8].DP.y, J[8].DDP.y
				);
		printf("%7.1f %13.5f %13.5f %13.5f\n", 
				th, J[4].P.x, J[4].P.y, J[8].P.x, J[8].P.y );

		theta.the = theta.the + PAI;
		ichk = MPQUADLEG ( L, gsi, eta, theta, theta0, J );
		if( ichk != SUCCESS ) {
			printf( "\n ++ Error in MPQUADLEG! ier= %d \n", ichk );
			exit ( 0 );
		}  
		fprintf(fpDAT, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f	%13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f \n",
			    th, 
				J[0].P.x, J[0].DP.x, J[0].DDP.x, J[0].P.y, J[0].DP.y, J[0].DDP.y,
				J[1].P.x, J[1].DP.x, J[1].DDP.x, J[1].P.y, J[1].DP.y, J[1].DDP.y,
				J[2].P.x, J[2].DP.x, J[2].DDP.x, J[2].P.y, J[2].DP.y, J[2].DDP.y,
				J[3].P.x, J[3].DP.x, J[3].DDP.x, J[3].P.y, J[3].DP.y, J[3].DDP.y,
				J[4].P.x, J[4].DP.x, J[4].DDP.x, J[4].P.y, J[4].DP.y, J[4].DDP.y,
				J[5].P.x, J[5].DP.x, J[5].DDP.x, J[5].P.y, J[5].DP.y, J[5].DDP.y,
				J[6].P.x, J[6].DP.x, J[6].DDP.x, J[6].P.y, J[6].DP.y, J[6].DDP.y,
				J[7].P.x, J[7].DP.x, J[7].DDP.x, J[7].P.y, J[7].DP.y, J[7].DDP.y,
				J[8].P.x, J[8].DP.x, J[8].DDP.x, J[8].P.y, J[8].DP.y, J[8].DDP.y
				);		
		printf("%7.1f %13.5f %13.5f %13.5f\n", 
				th, J[4].P.x, J[4].P.y, J[8].P.x, J[8].P.y );
	}

	fclose( fpDAT );
	fclose( fpCSV );
}
