//-----------------------------------------------------------
// 
//  @@ʃN@\ɂSs@B̋r@\̉^w
//
//           < mpquadleg.cpp >
//
//   L[5]     : ߒ
//   gsi[3], eta[3] :
//              Ԑ߂̕`_̓W
//   minv[3]  : @\]̃CWP[^
//   theta    : ߊpψʁEpxEpx
//   J[9]     : ΋̈ʒuExEx
//   ichk     : G[CWP[^
//                 ichk = 0   : G[Ȃ
//                 ichk = 991 : QAJ2J3J1\łȂ
//                 ichk = 992 : QAJ7J6J5\łȂ
//
//     ** KvTuvO **
//           crank_input
//           RRR_links
//           coupler_point
//
//     2015. 5.18 쐬 BY ╍
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"

int MPQUADLEG( double L[], double gsi[], double eta[], ANGLE theta, double theta0, POINT J[] )
{
	ANGLE biastheta;
	ANGLE dumma;
	POINT dummp;

	int ichk;
	int minv[2];

	dumma.the = dumma.dthe = dumma.ddthe = 0.0;
	dummp.P.x = dummp.DP.x = dummp.DDP.x = 0.0;
	dummp.P.y = dummp.DP.y = dummp.DDP.y = 0.0;


//------ ΋̕ψʁExEx ------

	minv[0] = -1;
	minv[1] =  1;

	biastheta.the = -theta.the + theta0;
	biastheta.dthe = -theta.dthe;
	biastheta.ddthe = -theta.ddthe;

	crank_input( J[0], L[0], biastheta, dumma, &J[2] );

	ichk = RRR_links( J[2], J[1], L[1], L[2],  minv[0], &J[3] );
	if( ichk != SUCCESS ) return ( 991 );

	coupler_point( J[2], J[3], gsi[0], eta[0], &J[4], &dumma );

	coupler_point( J[2], J[3], gsi[1], eta[1], &J[5], &dumma );

	ichk = RRR_links( J[7], J[5], L[4], L[3],  minv[1], &J[6] );
	if( ichk != SUCCESS ) return ( 992 );

	coupler_point( J[6], J[7], gsi[2], eta[2], &J[8], &dumma );

	return ( SUCCESS );
}