//----------------------------------------------------------
//
//  @@ eIZ@\ɂr@\̉^w͌vZ
//
//           < PmTheoJansen.cpp >
//
//   L[6]     : ߒ
//   gsi[4], eta[4] :
//              Ԑ߂̕`_̓W
//   theta0   : ߊpψʏl
//   theta    : ߊpψʁEpxEpx
//   J[11]    : ΋̈ʒuExEx
//   ichk     : G[CWP[^
//                 ichk = 0   : G[Ȃ
//                 ichk = 991 : QAJ3J2J1\łȂ
//                 ichk = 992 : QAJ6J5J4\łȂ
//                 ichk = 993 : QAJ7J9J8\łȂ
//
//     ** KvTuvO **
//           DRMTHEOJANSEN
//           MTHEOJANSEN
//
//     ** ̓f[^t@C **
//           IMDATA.dat (DRMTHEOJANSEN)
//
//     ** o̓f[^t@C **
//           PMTHEOJANSEN.dat
//           PMTHEOJANSEN.csv
//           PMTHEOJANSEN.trj
//
//     2019. 9.10 쐬 BY ╍ 
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"
#include "PmTheoJansen_subfunctions.h"

void main(void)
{
	double L[7];			// ߒ
	double gsi[4], eta[4];	// Ԑߕ`_̓W
	ANGLE theta;			// ߊpψʁEpxEp
	POINT J[11];			// ΋̈ʒuExEx
	double rpm;				// ߉]x
	double th;				// ߉]p
	double theta0;			// ߊpψʏl
	char   name[100];	    // vZҎ

	FILE *fpDAT, *fpCSV, *fpTRJ;
							// t@C|C^

	int i, ith;             // ƕϐ
	int ichk;               // G[CWP[^
	double tmpf[10];

//------ f[^ ------

	printf("** ́F");
	gets_s(name);
	printf("\n");

	DRMTHEOJANSEN( L, gsi, eta, &theta0, J );
	printf("** ߉]x [RPM]F\n");
	finput_val( tmpf, 1 );
	rpm = tmpf[0];

	theta.dthe = rpm*360/60*DR;
	theta.ddthe = 0;

//------ o̓t@C̃I[v (PMTHEOJANSEN.DAT,PMTHEOJANSEN.CSV,PMTHEOJANSEN.TRJj------

	if( fopen_s( &fpDAT, "PMTHEOJANSEN.DAT","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMTHEOJANSEN.DATJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpCSV, "PMTHEOJANSEN.CSV","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMTHEOJANSEN.CSVJ܂I\n");
		exit(0);
	}
	if( fopen_s( &fpTRJ, "PMTHEOJANSEN.TRJ","wt" ) != SUCCESS ){
		printf("++ G[ : t@CPMTHEOJANSEN.TRJJ܂I\n");
		exit(0);
	}


//------ ̏o ------

	fprintf(fpDAT, " by %s\n", name);
	fprintf(fpDAT, "with PMTHEOJANSEN.CPP\n"); 

	fprintf(fpDAT, "%13.5f %13.5f\n", J[0].P.x, J[0].P.y );
	fprintf(fpDAT, "%13.5f %13.5f\n", J[3].P.x, J[3].P.y );
	fprintf(fpDAT, "%13.5f %13.5f\n", J[6].P.x, J[6].P.y );
	for( i=0; i<7; i++ ) {
		fprintf(fpDAT, "%13.5f\n", L[i] );
	}
	for( i=0; i<4; i++ ) {
		fprintf(fpDAT, "%13.5f %13.5f\n", gsi[i], eta[i] );
	}
	fprintf( fpDAT, "%13.5f\n", theta0*RD );
	fprintf( fpDAT, "%13.5f\n", rpm);
	
	fprintf(fpCSV, "%s\n", name);
	fprintf( fpCSV, "The,XA,dXA,ddXA,YA,dYA,ddYA \n");

//------ C[v -------

	for( ith=0; ith<=360; ith++ ){
		th = (double)ith;
		theta.the = th*DR;
		
		ichk = MTHEOJANSEN ( L, gsi, eta, theta, theta0, J );
		if( ichk != SUCCESS ) {
			printf( "\n ++ Error in MTHEOJANSEN! ier= %d \n", ichk );
			exit ( 0 );
		}  
		fprintf(fpDAT, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f \n",
			    th, 
				J[10].P.x, J[10].DP.x, J[10].DDP.x, J[10].P.y, J[10].DP.y, J[10].DDP.y
				);
		fprintf(fpCSV, "%7.1f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f, %13.5f \n",
			    th, 
				J[10].P.x, J[10].DP.x, J[10].DDP.x, J[10].P.y, J[10].DP.y, J[10].DDP.y
				);
		fprintf(fpTRJ, "%7.1f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f %13.5f%13.5f %13.5f %13.5f %13.5f %13.5f %13.5f \n",
			    th, 
				J[ 0].P.x, J[ 0].P.y, J[ 1].P.x, J[ 1].P.y, J[ 2].P.x, J[ 2].P.y, J[ 3].P.x, J[ 3].P.y,
				J[ 4].P.x, J[ 4].P.y, J[ 5].P.x, J[ 5].P.y, J[ 6].P.x, J[ 6].P.y, J[ 7].P.x, J[ 7].P.y,
				J[ 8].P.x, J[ 8].P.y, J[ 9].P.x, J[ 9].P.y, J[10].P.x, J[10].P.y
				);
		printf("%7.1f %13.5f %13.5f \n", th, J[10].P.x, J[10].P.y);
	}

	fclose( fpDAT );
	fclose( fpCSV );
	fclose( fpTRJ );
}
