//-----------------------------------------------------------
// 
//   eIEZ@\̋@\̓ǂݍ
//
//          < drmTheoJansen.cpp >
//
//   L[6]     : ߒ
//   gsi[4], eta[4] :
//              Ԑ߂̕`_̓W
//   theta0   : ߊpψʏl
//   J[11]     : ΋̈ʒuExEx
//
//     ** Kvf[^t@C **
//          IMDATA.dat
//
//     2019. 9.10 쐬 BY ╍
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"

void DRMTHEOJANSEN( double L[], double gsi[], double eta[], double *theta0, POINT J[] )
{
	double tmpf[10];
	double La, Lb, Lc, Ld, Le, Lf, Lg, Lh, Li, Lj, Lk, Ll, Lm;
	double alp1, alp3;
	FILE *fp;

//------ @\̓ǂݍ ------

	if( fopen_s( &fp, "../IMDATA.dat","rt" ) != SUCCESS ){
		printf("++ G[ : t@CIMDATA.datJ܂I\n");
		exit(0);
	}

	fread_val( tmpf, 1, fp );
	La = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lb = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lc = tmpf[0];
	fread_val( tmpf, 1, fp );
	Ld = tmpf[0];
	fread_val( tmpf, 1, fp );
	Le = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lf = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lg = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lh = tmpf[0];
	fread_val( tmpf, 1, fp );
	Li = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lj = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lk = tmpf[0];
	fread_val( tmpf, 1, fp );
	Ll = tmpf[0];
	fread_val( tmpf, 1, fp );
	Lm = tmpf[0];
	fread_val( tmpf, 1, fp );
	*theta0 = tmpf[0]*DR;

	fclose(fp);

//------ @\̐ݒ ------

	J[0].P.x = 0.0;
	J[0].P.y = 0.0;
	J[3].P.x = -La;
	J[3].P.y = -Ll;
	J[6].P.x = -La;
	J[6].P.y = -Ll;
	
	L[0] = Lm;
	L[1] = Lj;
	L[2] = Lb;
	L[3] = Lk;
	L[4] = Lc;
	L[5] = Lf;
	L[6] = Lg;

	gsi[0] = Lm;
	eta[0] = 0.0;
	alp1 = acos( ( Ld*Ld + Lb*Lb - Le*Le )/( 2.0*Ld*Lb ) );
	gsi[1] = Ld*cos( alp1 );
	eta[1] = Ld*sin( alp1 );
	gsi[2] = Lc;
	eta[2] = 0.0;
	alp3 = acos( ( Lg*Lg + Lh*Lh - Li*Li )/( 2.0*Lg*Lh ) );
	gsi[3] =  Lh*cos( alp3 );
	eta[3] = -Lh*sin( alp3 );

//------ Î~΋̑xEx ------

	J[0].DP.x = J[0].DDP.x = 0.0;
	J[0].DP.y = J[0].DDP.y = 0.0;
	J[3].DP.x = J[3].DDP.x = 0.0;
	J[3].DP.y = J[3].DDP.y = 0.0;
	J[6].DP.x = J[6].DDP.x = 0.0;
	J[6].DP.y = J[6].DDP.y = 0.0;
}
