//--------------------------------------------------------
//
//             JȐ̌vZ
//
//             < CAMCURVE.CPP >
//
// ** ϐ **
//    T         : 
//    S         : ψ
//    V         : x
//    A         : x
//	  J         : 
//
// ** o̓f[^t@C **
//    Camcurve.dat
//	  Camcurve.csv
//
//      2004. 7. 1 쐬  BY ╍
//      2005. 7. 7   BY ╍
//      2010. 7. 1   BY ╍
//      2021.10.17   BY ╍
//
//---------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

static char  your_name[20];

static double  pai, pai2, dtr, rtd;

int constants( void )
{
//------ 萔̐錾 ------

    pai= 3.141592653589793;     // 
    pai2 =pai*2.0;              // 2
    dtr = pai/180.0;            // fO[EfBAϊ
    rtd = 180.0/pai;            // fBAEfO[ϊ
	return ( 0 );
}

void main ( void )
{
    int  j;                     // ƕϐ
	double T, S, V, A, J;       // p[^
	char   name[100];           // vZҖ    
    FILE *fpDAT, *fpCSV;        // t@C|C^

//---- 萔ݒ ----

    constants();
    
//---- f[^ ----

	printf("** : ");
	gets_s(name);
	printf("\n");

	if( ( fopen_s(&fpDAT, "Camcurve.dat", "wt")) != 0 ) {       // o̓t@C Camcurve.DATI[v
		printf("++ G[ : t@C Camcurve.dat J܂.\n");
		exit(1);
	}

	if( ( fopen_s(&fpCSV, "Camcurve.csv", "wt")) != 0 ) {       // o̓t@C Camcurve.CSVI[v
		printf("++ G[ : t@C Camcurve.csv J܂.\n");
		exit(1);
	}

	fprintf( fpDAT, "by %s\n", name );
	fprintf( fpDAT, "%s\n", "CAMCURVE.CPP" );
    fprintf( fpCSV, "S, V, A, J\n" );

	for(j=0;j<=1000;j++)  {
        T =( (double)j )/1000.0;

//----- TCNCh֐ -----

        S = T - sin( pai2*T )/pai2;
	    V = 1.0 - cos( pai2*T );
        A = pai2*sin( pai2*T );
		J = pai2*pai2*cos( pai2*T );

//----- T◯֐ -----
/*
		S = ( 10.0 - 15.0*T + 6.0*T*T )*T*T*T;
		V = ( 30.0 - 60.0*T + 30.0*T*T )*T*T;
		A = ( 60.0 - 180.0*T + 120.0*T*T )*T;
		J = 60.0 - 360.0*T +360.0*T*T;
*/

        fprintf( fpDAT,"%13.8f %13.8f %13.8f %13.8f %13.8f \n",
                      T, S, V, A, J );
        fprintf( fpCSV,"%13.8f, %13.8f, %13.8f, %13.8f, %13.8f, \n",
                      T, S, V, A, J );
     }

    fclose( fpDAT );                   // CAMCURVE.DAT N[Y
    fclose( fpCSV );                   // CAMCURVE.CSV N[Y
}  
