﻿Public Class RCamcurve
  '--------------------------------------------------------------------------
  '
  '     　　　  カム曲線の計算
  '
  '            < RCAMCURVE.BAS >
  '
  '       2004. 7. 2 作成 BY 岩附
  '       2005. 7. 7 修整 BY 岩附
  '       2010. 7. 1 修整 BY 岩附
  '       2021.10.17 修整 BY 岩附
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 1 ' ページ数
  Dim STUDENT_NAME As String ' 学生氏名
  Dim PROGRAM_NAME As String ' プログラム名
  '
  Dim T(1001), S(1001), V(1001), A(1001), J(1001) As Double
  Dim VM, AM, JM, QM As Double
  '
  Private Sub Exe()
    Dim i As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    GoTo PEND
    '
PAGE1:
    FileOpen(1, "../../../CAMCURVE.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    VM = 0.0
    AM = 0.0
    JM = 0.0
    QM = 0.0
    For i = 1 To 1001 Step 1
      Input(1, T(i))
      Input(1, S(i))
      Input(1, V(i))
      Input(1, A(i))
      Input(1, J(i))
      If Math.Abs(V(i)) > VM Then VM = Math.Abs(V(i))
      If Math.Abs(A(i)) > AM Then AM = Math.Abs(A(i))
      If Math.Abs(V(i)) > JM Then JM = Math.Abs(J(i))
      If Math.Abs(V(i) * A(i)) > QM Then QM = Math.Abs(V(i) * A(i))
    Next i
    FileClose(1)
    '
    PLOTS(graph)
    Phead()
    '
    NDPLOT = 1001
    X0PLOT = 2.0 : Y0PLOT = 12.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 4.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 2 : NDYPLOT = 2
    XMINPLOT = 0.0 : YMINPLOT = 0.0
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0
    XANAME = "T" : YANAME = "S"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = T(i)
      YPLOT(i) = S(i)
    Next i
    GAXES(graph)
    NUMPEN = 2
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 6.8
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 4.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 2 : NDYPLOT = 2
    XMINPLOT = 0.0 : YMINPLOT = 0.0
    XMAXPLOT = 1.0 : YMAXPLOT = 4.0
    XANAME = "T" : YANAME = "V"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = T(i)
      YPLOT(i) = V(i)
    Next i
    GAXES(graph)
    NUMPEN = 2
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 1.6
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 4.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 2 : NDYPLOT = 0
    XMINPLOT = 0.0 : YMINPLOT = -10.0
    XMAXPLOT = 1.0 : YMAXPLOT = 10.0
    XANAME = "T" : YANAME = "A"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = T(i)
      YPLOT(i) = A(i)
    Next i
    GAXES(graph)
    NUMPEN = 2
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = -3.6
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0# : YFPLOT = 4.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 2 : NDYPLOT = 0
    XMINPLOT = 0.0 : YMINPLOT = -100.0
    XMAXPLOT = 1.0 : YMAXPLOT = 100.0
    XANAME = "T" : YANAME = "J"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = T(i)
      YPLOT(i) = j(i)
    Next i
    GAXES(graph)
    NUMPEN = 2
    '
    SLINE(graph)
    '
    PXSYMBOL = 1.0#
    PYSYMBOL = -5
    SYMBOL = "VM=" + Str$(VM) + " AM=" + Str$(AM)
    PSYMBOL(graph)
    PXSYMBOL = 1.0#
    PYSYMBOL = -5.6
    SYMBOL = "JM=" + Str$(JM) + " QM=" + Str$(QM)
    PSYMBOL(graph)
    '
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "カム曲線"
    PSYMBOL(graph)
    '
    PXSYMBOL = 5.0
    PYSYMBOL = 17.0
    SYMBOL = "by RCAMCURVE.BAS"
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
