//--------------------------------------------------------
//
//        [[h]ߔJ̐݌v
//
//             < PCAMDESIGNROF.CPP >
//
// 萔 :
//    pai, pai2  : ΁C2
//    dtr, rtd   : WA|xϊW
//
//    lf         : tHN@[m]
//    rf         : [a@[m]
//    xp, yp     : s{bg̍WiÎ~nj[m]
//
//  ϐ :
//    xr, yr, dxrdt, dyrdt :
//                 J[SWiJWnj
//                 Ƃ̃J]pΔl [m], [m/rad]
//
//    the        : J̉]pCpxCpx [rad]
//	  phi, dphi  : tHN̗hp
//                 Ƃ̃J]pΔl [rad], [rad/rad]
//    psic       : JWnɂJ֊s_̊pʒu@[rad]
//    rc         : JWnɂJ֊s_̓a@[m]
//    xc, yc     : JWnɂJ֊s_̈ʒu@[m]
//    alp        : ͊p@[rad]
//
//  o̓f[^t@C:
//    PCAMDESIGNROF.DAT : Visual Basic@̂߂̃eLXgf[^
//	  PCAMDESIGNROF.CSV : MS-EXCEL@̂߂CSVf[^
//    PCAMDESIGNROF.TXT : SolidWorks  ̂߂̃eLXgf[^
//
//      2003. 7. 2  쐬@by N. IWATSUKI
//	    2004. 7. 1  C@by N. IWATSUKI
//	    2005. 7. 7  C@by N. IWATSUKI
//	    2006. 7. 6  ǁ@by N. IWATSUKI
//	    2010. 7. 1  ǁ@by N. IWATSUKI
//      2021.10.17    by N, IWATSUKI
//
//---------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

static char  name[20];

static double  pai, pai2, dtr, rtd;
static double  lf, rf, xp, yp;
static double  xc, yc;
static double  rc, psic;
static double  alp;
static double  xr, yr, dxr, dyr;
static double  the;
static double  phi, dphi;

//----- z֐ -----
//----- v݌v -----

int desfunc() {               // o͊p֌WƂ̔l
    double  phimax, phimin, phiamp;
	double  r, r2, r3, r4, r5, drdthe;
    double  the1, the2, the3;

    phimax = 150.0*dtr;
    phimin = 130.0*dtr;
    phiamp = phimax - phimin;

    the1 = 150.0*dtr;
    the2 = 200.0*dtr;
    the3 = 300.0*dtr;
	                         // T◯֐Œ`
	if( the<=the1 )  {
      r = the/the1;
	  drdthe = 1.0/the1;
	  r2 = r*r;
      r3 = r2*r;
      r4 = r3*r;
      r5 = r4*r;
      phi = phiamp*( 6.0*r5 - 15.0*r4 + 10.0*r3 ) + phimin;
	  dphi = phiamp*( 30.0*r4 - 60.0*r3 + 30.0*r2 )*drdthe;
	}
	else {
      if( the<=the2 )  {
        phi = phimax;
		dphi = 0.0;
	  }
	  else  {
	    if( the<=the3 )  {
	      r = ( the - the2 )/( the3 - the2 );
		  drdthe = 1.0/( the3 - the2 );
		  r2 = r*r;
          r3 = r2*r;
          r4 = r3*r;
          r5 = r4*r;
          phi = -phiamp*( 6.0*r5 - 15.0*r4 + 10.0*r3 ) + phimax;
 	      dphi = -phiamp*( 30.0*r4 - 60.0*r3 + 30.0*r2 )*drdthe;
       }
		else  {
		  phi = phimin;
		  dphi = 0.0;
		}
	  }
	}
	return ( 0 );
}

//------ 萔̐錾 ------


int constants( void )
{
    pai= 3.141592653589793;     // 
    pai2 =pai*2.0;              // 2
    dtr = pai/180.0;            // fO[EfBAϊ
    rtd = 180.0/pai;            // fBAEfO[ϊ
	return ( 0 );
}

//----- J̗֊sȐ̌vZ -----

int solcfo( void ){
    double cp, sp, ct,st;
    double dxrdt, dyrdt;
    double qkamp, qkx, qky;
	double prx, pry, apr;
	double crx, cry, acr;

    desfunc();

    cp = cos( phi );
    sp = sin( phi );
   
    ct = cos( the );
    st = sin( the );
     
    xr = lf*( cp*ct + sp*st ) + xp*ct + yp*st;
    yr = lf*( sp*ct - cp*st ) - xp*st + yp*ct;

    dxrdt = lf*( -dphi*sp*ct - cp*st + dphi*cp*st + sp*ct ) - xp*st + yp*ct;
    dyrdt = lf*(  dphi*cp*ct - sp*st + dphi*sp*st - cp*ct ) - xp*ct - yp*st;

	qkamp = sqrt( 1.0 + dyrdt*dyrdt/( dxrdt*dxrdt ) );
	qkx = 1.0/qkamp;
    qky = dyrdt/dxrdt/qkamp;
	if( xr*qky - yr*qkx > 0.0 )  {
		qkx = -qkx;
		qky = -qky;
	}
    xc = xr + rf*qky;
	yc = yr - rf*qkx;

	rc = sqrt( xc*xc + yc*yc );
    psic = atan2( yc, xc );

    crx = xr - xc;
	cry = yr - yc;
	acr = sqrt( crx*crx + cry*cry );

	prx = xr - xp*ct - yp*st;
	pry = yr + xp*st - yp*ct;
    apr = sqrt( prx*prx + pry*pry );

	alp = fabs( acos( ( crx*prx + cry*pry )/( acr*apr ) ) - pai*0.5 ); 

    return ( 0 );
}

//----- CvO -----

void main ( void )
{
    int  j;                        // ƕϐ
	double zc = 0.0;               // J֊sȐ
    
    FILE *fpDAT, *fpCSV, *fpTXT;   // t@C|C^


//---- 萔ݒ ----

    constants();
	
//---- f[^ ----

	printf("** : ");     //--- v݌v ---
	gets_s(name);
	printf("\n");

    xp =  0.125;                   //--- s{bgW [m] ---
    yp = -0.05;

    rf =  0.011;                   //--- J[a [m] ---
    lf =  0.120;                   //--- JtHNiJj[m] ---

	if( ( fopen_s(&fpDAT, "PCAMDESIGNORF.DAT", "wt")) != 0 ) {       // o̓t@C PCAMDESIGNORF.DATI[v
		printf("++ G[ : t@C PCAMDESIGNORF.DAT J܂.\n");
		exit(1);
	}

	if( ( fopen_s(&fpCSV, "PCAMDESIGNORF.CSV", "wt")) != 0 ) {       // o̓t@C PCAMDESIGNORF.CSVI[v
		printf("++ G[ : t@C PCAMDESIGNORF.CSV J܂.\n");
		exit(1);
	}

	if( ( fopen_s(&fpTXT, "PCAMDESIGNORF.TXT", "wt")) != 0 ) {       // o̓t@C PCAMDESIGNORF.TXTI[v
		printf("++ G[ : t@C PCAMDESIGNORF.TXT J܂.\n");
		exit(1);
	}

	fprintf( fpDAT, "by %s\n", name );
	fprintf( fpDAT, "%s\n", "PCAMDESIGNORF.CPP" );
    fprintf( fpDAT, "%14.10f %14.10f %14.10f %14.10f\n",
                     xp, yp, rf, lf );
    fprintf( fpCSV, "The, Phi, Xr, Yr\n" );

//----- J̗֊sȐ̌vZ -----

	for(j=0;j<=360;j++)  {
        the =( (double)j )*dtr;

        desfunc();

		xr = xp + lf*cos( phi );
		yr = yp + lf*sin( phi );

        fprintf( fpDAT,"%6.1f %13.8f %13.8f %13.8f \n",
                      the*rtd, phi*rtd, xr, yr );
        fprintf( fpCSV,"%6.1f, %13.8f, %13.8f, %13.8f \n",
                      the*rtd, phi*rtd, xr, yr );
    }

    fprintf( fpCSV, "The, R, Psi, Xc, Yc, Alp \n" );

	for(j=0;j<=360;j++)  {
        the =( (double)j )*dtr;
 
		solcfo();

	    xc = rc*cos( psic );
        yc = rc*sin( psic );

        fprintf( fpDAT,"%6.1f %13.8f %13.8f %13.8f %13.8f %13.8f \n",
                      the*rtd, rc, psic*rtd, xc, yc, alp*rtd );
        fprintf( fpCSV,"%6.1f, %13.8f, %13.8f, %13.8f, %13.8f %13.8f\n",
                      the*rtd, rc, psic*rtd, xc, yc, alp*rtd );
        fprintf( fpTXT,"%13.8f %13.8f %13.8f \n", xc*1000.0, yc*1000.0, zc*1000.0 );
    }

    fclose( fpDAT );                   // PCAMDESIGNORF.DAT N[Y
    fclose( fpCSV );                   // PCAMDESIGNORF.CSV N[Y
    fclose( fpTXT );                   // PCAMDESIGNORF.TXT N[Y
}  
