﻿Public Class RPcamdesignORF
  '--------------------------------------------------------------------------
  '
  '   　　　   ローラ端揺動従節板カムの設計　
  '
  '              < RPCAMDESIGNORL.BAS >
  '
  '
  '       2002.11.16 作成 BY 岩附
  '       2003.11.17 改良 BY 岩附
  '       2004. 7. 1 改良 BY 岩附
  '       2005. 7. 7 改良 BY 岩附
  '       2006. 7. 6 改良 BY 岩附
  '       2010. 7. 1 改良 BY 岩附
  '       2021.10.17 改良 BY 岩附
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 8 ' ページ数
  Dim STUDENT_NAME As String ' 学生氏名
  Dim PROGRAM_NAME As String ' プログラム名
  '
  Dim PSD(370) As Double, RC(370) As Double, XC(370) As Double, YC(370) As Double, ALP(370) As Double
  Dim XP, YP, RF, QLF As Double
  Dim THD(370) As Double, PSIC(370) As Double, PHI(370) As Double
  Dim XB(370), YB(370) As Double
  Dim NDPLOTB As Integer
  '
  Private Sub Exe()
    Dim i, k, kk As Integer
    Dim TH, CT, ST As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    If P_page = 6 Then GoTo PAGE6
    If P_page = 7 Then GoTo PAGE7
    If P_page = 8 Then GoTo PAGE8
    GoTo PEND
    '
PAGE1:
    FileOpen(1, "../../../PCAMDESIGNORF.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, XP) : Input(1, YP) : Input(1, RF) : Input(1, QLF)
    '
    XP = XP * 1000.0
    YP = YP * 1000.0
    RF = RF * 1000.0
    QLF = QLF * 1000.0
    For i = 1 To 361 Step 1
      Input(1, THD(i))
      Input(1, PHI(i))
      Input(1, XB(i))
      Input(1, YB(i))
      '
      XB(i) = XB(i) * 1000.0
      YB(i) = YB(i) * 1000.0
    Next i
    For i = 1 To 361 Step 1
      Input(1, THD(i))
      Input(1, RC(i))
      Input(1, PSIC(i))
      Input(1, XC(i))
      Input(1, YC(i))
      Input(1, ALP(i))
      '
      XC(i) = XC(i) * 1000.0
      YC(i) = YC(i) * 1000.0
      RC(i) = RC(i) * 1000.0
    Next i
    FileClose(1)
    '
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "フォロワ出力角変位"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 5.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 10.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = 0.0 : YMINPLOT = 120
    XMAXPLOT = 360 : YMAXPLOT = 160
    XANAME = "θ°" : YANAME = "φ°"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THD(i)
      YPLOT(i) = PHI(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    GoTo PEND
    '
PAGE2:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "カム輪郭"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 2.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 12.0
    NXPLOT = 24 : NYPLOT = 24
    NVXPLOT = 2 : NVYPLOT = 2
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -120.0 : YMINPLOT = -120.0
    XMAXPLOT = 120.0 : YMAXPLOT = 120.0
    XANAME = "x mm" : YANAME = "y mm"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XC(i)
      YPLOT(i) = YC(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    NDPLOT = 1
    XPLOT(1) = 0
    YPLOT(1) = 0
    CPLOT(graph)
    GoTo PEND
    '
PAGE3:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "カム輪郭の座標"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = -3.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 10.0 : YFPLOT = 5.0
    NXPLOT = 4 : NYPLOT = 5
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -200.0 : YMINPLOT = -150.0
    XMAXPLOT = 200.0 : YMAXPLOT = 100.0
    XANAME = "ψ °" : YANAME = "x mm"
    NDPLOT = 361
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = PSIC(i)
      YPLOT(i) = XC(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 3.5
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 10.0 : YFPLOT = 5.0
    NXPLOT = 4 : NYPLOT = 5
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -200.0 : YMINPLOT = -100.0
    XMAXPLOT = 200.0 : YMAXPLOT = 150.0
    XANAME = "ψ°" : YANAME = "y mm"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YC(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 10.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 10.0 : YFPLOT = 5.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -200.0 : YMINPLOT = 0.0
    XMAXPLOT = 200.0 : YMAXPLOT = 80.0
    XANAME = "ψ°" : YANAME = "r mm"
    PSCALE()
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = PSIC(i)
      YPLOT(i) = RC(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    GoTo PEND
    '
PAGE4:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "カムとフォロワ"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 15.0 : YFPLOT = 15.0
    NXPLOT = 6 : NYPLOT = 6
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -150.0 : YMINPLOT = -150.0
    XMAXPLOT = 150.0 : YMAXPLOT = 150.0
    XANAME = "x mm" : YANAME = "y mm"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XC(i)
      YPLOT(i) = YC(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    NDPLOTB = NDPLOT
    NDPLOT = 2
    XPLOT(1) = XB(1)
    YPLOT(1) = YB(1)
    XPLOT(2) = XP
    YPLOT(2) = YP
    NUMPEN = 2
    SLINE(graph)
    CPLOT(graph)
    '
    NUMPEN = 2
    NDPLOT = NDPLOTB
    For k = 1 To 361 Step 10
      NDPLOT = 361
      TH = CDbl(k - 1) * DR
      CT = Math.Cos(TH)
      ST = Math.Sin(TH)
      For i = 1 To NDPLOT
        XPLOT(i) = CT * XC(i) - ST * YC(i)
        YPLOT(i) = ST * XC(i) + CT * YC(i)
      Next i
      SLINE(graph)
      '
      NDPLOT = 1
      XPLOT(1) = XB(k)
      YPLOT(1) = YB(k)
      ROLLERPLOT()
      '
      NDPLOT = 2
      XPLOT(2) = XB(k)
      YPLOT(2) = YB(k)
      XPLOT(1) = XP
      YPLOT(1) = YP
      NUMPEN = 2
      SLINE(graph)
      NDPLOT = 1
      CPLOT(graph)
      '
    Next k
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XC(i)
      YPLOT(i) = YC(i)
    Next i
    NUMPEN = 1
    SLINE(graph)
    '
    NDPLOT = 1
    XPLOT(1) = XB(1)
    YPLOT(1) = YB(1)
    ROLLERPLOT()
    NDPLOT = 2
    XPLOT(2) = XB(1)
    YPLOT(2) = YB(1)
    XPLOT(1) = XP
    YPLOT(1) = YP
    '
    NUMPEN = 1
    SLINE(graph)
    NDPLOT = 1
    CPLOT(graph)
    GoTo PEND
    '
PAGE5:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "カム座標系から"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 15.0 : YFPLOT = 15.0
    NXPLOT = 6 : NYPLOT = 6
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -150.0 : YMINPLOT = -150.0
    XMAXPLOT = 150.0 : YMAXPLOT = 150.0
    XANAME = "x mm" : YANAME = "y mm"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XC(i)
      YPLOT(i) = YC(i)
    Next i
    NUMPEN = 1
    SLINE(graph)
    NDPLOT = 1
    XPLOT(1) = 0.0
    YPLOT(1) = 0.0
    CPLOT(graph)
    '
    NUMPEN = 2
    PENTHICK = 1
    For k = 1 To 361 Step 10
      NDPLOT = 1
      TH = CDbl(k) * DR
      CT = Math.Cos(-TH)
      ST = Math.Sin(-TH)
      XPLOT(1) = CT * XB(k) - ST * YB(k)
      YPLOT(1) = ST * XB(k) + CT * YB(k)
      ROLLERPLOT()
      XPLOT(2) = CT * XP - ST * YP
      YPLOT(2) = ST * XP + CT * YP
      NDPLOT = 2
      SLINE(graph)
      CPLOT(graph)
    Next k
    GoTo PEND
    '
PAGE6:
    For kk = 1 To 3 Step 1
      For k = 1 To 361 Step 2
        TH = CDbl(k - 1) * DR
        CT = Math.Cos(TH)
        ST = Math.Sin(TH)
        '
        PLOTS(graph)
        Phead()
        '
        PXSYMBOL = 1.0
        PYSYMBOL = 16.4
        SYMBOL = "アニメーション"
        PSYMBOL(graph)
        '
        X0PLOT = 2.0 : Y0PLOT = 0.0
        XSPLOT = 0.0 : YSPLOT = 0.0
        XFPLOT = 15.0 : YFPLOT = 15.0
        NXPLOT = 6 : NYPLOT = 6
        NVXPLOT = 1 : NVYPLOT = 1
        NDXPLOT = 0 : NDYPLOT = 0
        XMINPLOT = -150.0 : YMINPLOT = -150.0
        XMAXPLOT = 150.0 : YMAXPLOT = 150.0
        XANAME = "x mm" : YANAME = "y mm"
        PSCALE()
        GAXES(graph)
        '
        NUMPEN = 2
        NDPLOT = 1
        XPLOT(1) = 0.0
        YPLOT(1) = 0.0
        CPLOT(graph)
        '
        NDPLOT = 361
        For i = 1 To NDPLOT Step 1
          XPLOT(i) = CT * XC(i) - ST * YC(i)
          YPLOT(i) = ST * XC(i) + CT * YC(i)
        Next i
        SLINE(graph)
        '
        NDPLOT = 1
        XPLOT(1) = XB(k)
        YPLOT(1) = YB(k)
        ROLLERPLOT()
        '
        NDPLOT = 2
        XPLOT(2) = XB(k)
        YPLOT(2) = YB(k)
        XPLOT(1) = XP
        YPLOT(1) = YP
        NUMPEN = 2
        SLINE(graph)
        CPLOT(graph)
        '
        PictureBox1.Refresh() '描画のリフレッシュ
        System.Threading.Thread.Sleep(10) '10msec停止
        System.Windows.Forms.Application.DoEvents()
      Next k
    Next kk
    GoTo PEND
    '
PAGE7:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "カム輪郭"
    PSYMBOL(graph)
    '
    X0PLOT = 0.0 : Y0PLOT = -6.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 20.0 : YFPLOT = 20.0
    NXPLOT = 4 : NYPLOT = 4
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = -100.0 : YMINPLOT = -100.0
    XMAXPLOT = 100.0 : YMAXPLOT = 100.0
    XANAME = "x mm" : YANAME = "y mm"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XC(i)
      YPLOT(i) = YC(i)
    Next i
    NUMPEN = 7
    SLINE(graph)
    '
    NDPLOT = 2
    XPLOT(1) = 0
    YPLOT(1) = 0
    For k = 0 To 355 Step 5
      TH = CDbl(k) * DR
      XPLOT(2) = 100.0 * Math.Cos(TH)
      YPLOT(2) = 100.0 * Math.Sin(TH)
      NUMPEN = 1
      If k Mod 10 = 0 Then PENTHICK = 1 Else PENTHICK = 2
      If k = 0 Then NUMPEN = 2
      If k = 90 Then NUMPEN = 2
      If k = 180 Then NUMPEN = 2
      If k = 270 Then NUMPEN = 2
      SLINE(graph)
    Next k
    GoTo PEND
    '
PAGE8:
    PLOTS(graph)
    Phead()
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 16.4
    SYMBOL = "圧力角"
    PSYMBOL(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 5.0
    XSPLOT = 0.0 : YSPLOT = 0.0
    XFPLOT = 12.0 : YFPLOT = 10.0
    NXPLOT = 4 : NYPLOT = 9
    NVXPLOT = 1 : NVYPLOT = 1
    NDXPLOT = 0 : NDYPLOT = 0
    XMINPLOT = 0.0# : YMINPLOT = 0
    XMAXPLOT = 360 : YMAXPLOT = 90
    XANAME = "θ°" : YANAME = "α°"
    PSCALE()
    NDPLOT = 361
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THD(i)
      YPLOT(i) = ALP(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "ローラ端揺動従節板カムの輪郭計算　by　PCAMDESIGNORF.BAS"
    PSYMBOL(graph)
  End Sub
  Private Sub ROLLERPLOT()
    Dim i, P_XPS, P_YPS As Integer
    Dim RTEMP, DTEMP As Integer
    RTEMP = Int(RF * P_XRA * P_SCF)
    DTEMP = RTEMP * 2
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(Brushes.White, P_XPS - RTEMP, P_YPS - RTEMP, DTEMP, DTEMP)
      graph.DrawEllipse(P_PKIND, P_XPS - RTEMP, P_YPS - RTEMP, DTEMP, DTEMP)
    Next i
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
