//----------------------------------------------------
//
//      RRxJwbh
//          ̓vbgtH[̋t^wvZ
//
//          < IK3DCH.CPP >
//
//
//   PSUM[3]        : vbgtH[̋΋ʒuxNg
//                   iWnCWj
//   PLF[3]         : Î~vbgtH[̒i΋\
//                    KCh̋Ԓ̓_̈ʒuxNg
//   TLT[3][3][3],  double dTLT[3][3][3], double ddTLT[3][3][3]
//                  : ֐߂ɌŒ肵Wn̍Wϊsi]uj
//   PSLM[3]        : i΋ɌŒ肵Wnɂ鋅΋
//                    ʒuxNg
//   A              : vbgtH[̊p^
//   TT[3][3], dTT[3][3], ddTT[3][3] :
//                    vbgtH[̍Wϊsi]uj
//                    Ƃ̔
//   OMG            : vbgtH[̊pxEpx

//   PSUF[3]        : vbgtH[̋΋ʒu
//                   iÎ~WnCWj
//   PPF[3]         : i΋ʒuxNg(Î~WnCWj
//   PSLF[3]        : ͐ߏ̋΋ʒu
//                   iÎ~WnCWj
//   THE[3]         : AN`G[^͂Ƃ̔
//
//      ** KvȃTuvO **
//          init_joint
//          RPYTT
//          RPYAVELO 
//          TRANS
//          s_SSP_links
//
//     2010. 8.21  쐬 BY ╍
//     2018. 4.18   BY ╍
//
//---------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "mech.h"
#include "matrix.h"

int IK3DCH ( double L,
			  POSITION PSUM[3],
			  POSITION PLF[3],
		      double TLT[3][3][3],  double dTLT[3][3][3], double ddTLT[3][3][3],
			  VECTOR3 PSLM[3],
			  POSTURE A,
              double TT[3][3] , double dTT[3][3], double ddTT[3][3],
              AVELOCITY *OMG,
              POSITION PSUF[5], POSITION PPF[5], POSITION PSLF[3],
			  VARIABLE THE[3] )
{

	VECTOR3 wm1;
	POSITION PF, P;
	int minv;                         // A̔]CWP[^
	int i, ier;                       // ƕϐ

    init_joint( &PF );
    init_joint( &P );

	minv = -1;

//---- Wϊs ----

	RPYTT ( A, TT, dTT, ddTT );

//---- vbgtH[̊pxEpx ----

	RPYAVELO ( A, OMG );

//---- vbgtH[̋΋̕ψʂƂ̔ ----

	for(i=0;i<3;i++)  {

		wm1.x = PSUM[i].P.x;
		wm1.y = PSUM[i].P.y;
		wm1.z = PSUM[i].P.z;

		TRANS ( wm1, P, TT, dTT, ddTT, &PF );

		PSUF[i].P.x = PF.P.x;
		PSUF[i].P.y = PF.P.y;
		PSUF[i].P.z = PF.P.z;

		PSUF[i].DP.x = PF.DP.x;
		PSUF[i].DP.y = PF.DP.y;
		PSUF[i].DP.z = PF.DP.z;

		PSUF[i].DDP.x = PF.DDP.x;
		PSUF[i].DDP.y = PF.DDP.y;
		PSUF[i].DDP.z = PF.DDP.z;
	}

//---- AN`G[^͂̌vZ ----

	for(i=0;i<3;i++) {
		ier = s_SSP_links ( PSUF[i],
					        L,
							PLF[i],
							TLT[i], dTLT[i], ddTLT[i], 
							PSLM[i],
							minv,
							&THE[i],
							&PPF[i],
							&PSLF[i] );
		if( ier != SUCCESS ) {
			printf( "++ Error in IK3DCH iA\ł܂j\n");
			return ERROR;
		}
	}
	return SUCCESS;
}
