//----------------------------------------------------------
//  
//      RRxJwbh̋@\萔̋t^w 
//
//                < PIK3DCH.CPP >             
//
//   RU, ZU         : vbgtH[̋΋ʒu
//  @@            iWnC~Wj
//   RL, ZL         : Î~vbgtH[̒i΋\
//                    KCh̋Ԓ̓_̈ʒu
//                   iÎ~WnC~Wj
//   L              : ߒi΋ԋj
//                    KCh̋Ԓ̓_̈ʒu
//   PSUM[3]        : vbgtH[̋΋ʒuxNg
//                   iWnCWj
//   PLF[3]         : Î~vbgtH[̒i΋\
//                    KCh̋Ԓ̓_̈ʒuxNg
//   TLT[3][3][3],  double dTLT[3][3][3], double ddTLT[3][3][3]
//                  : ֐߂ɌŒ肵Wn̍Wϊsi]uj
//   PSLM[3]        : i΋ɌŒ肵Wnɂ鋅΋
//                    ʒuxNg
//   A_amp, A_phase, A_period :
//                   vbgtH[̊p^w
//                   (֐쓮)
//   A              : vbgtH[̊p^
//   TT[3][3], dTT[3][3], ddTT[3][3] :
//                    vbgtH[̍Wϊsi]uj
//                    Ƃ̔
//   OMG            : vbgtH[̊pxEpx

//   PSUF[3]        : vbgtH[̋΋ʒu
//                   iÎ~WnCWj
//   PPF[3]         : i΋ʒuxNg(Î~WnCWj
//   PSLF[3]        : ͐ߏ̋΋ʒu
//                   iÎ~WnCWj
//   THE[3]         : AN`G[^͂Ƃ̔
//
//     ** KvȃTuvO **
//           DRM3DCH
//           DRE3DCH
//           EE3DCH
//           IK3DCH
//
//     ** Kvȃf[^t@C **
//           IMDATA.DAT (DRM3DCH)
//
//     ** o̓f[^t@C **
//           PIK3DCH.DAT
//           PIK3DCH.CSV
//
//     2010. 8.21  쐬 BY ╍
//     2018. 4.18   BY ╍
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"
#include "matrix.h"
#include "Pik3Dch_subfunctions.h"
			
void main(void)
{

//---- ϐ̐錾 ----

	POSTURE A;
	AVELOCITY OMG;

	POSITION PSUM[3];
	POSITION PLF[3];
	POSITION PSLF[3];
	POSITION PSUF[3];
	POSITION PPF[3];
    VECTOR3 PSLM[3];
	VECTOR3 A_amp, A_phase, A_period;
	VARIABLE THE[3];

	double RL, ZL, RU, ZU, L;
	double TT[3][3], dTT[3][3], ddTT[3][3];

	double TLT[3][3][3], dTLT[3][3][3], ddTLT[3][3][3];

    double op_time;
	double time;		       // 
	char name[100];            // w

	FILE *fpDAT, *fpCSV;       // t@C|C^

	int i;                   // ƕϐ
	int ier;

//---- f[^ ----

	printf("** ́F ");
	gets_s(name);

	DRM3DCH( &RU, &ZU,
             &RL, &ZL,
			 &L,
		     PSUM,
			 PLF,
		     TLT, dTLT, ddTLT, 
			 PSLM );    // @\萔̓ǂݍ

	DRE3DCH( &op_time, 
			     &A_amp, &A_phase, &A_period );              // vbgtH[̉^ݒ

//---- ̏o -----

	if( fopen_s( &fpDAT, "PIK3DCH.dat", "wt") != SUCCESS ) {       // o̓t@C PIK3DCH.datI[v
		printf("G[ : t@C PIK3DCH.dat J܂.\n");
		exit(1);
	}

	if( fopen_s( &fpCSV, "PIK3DCH.csv", "wt") != SUCCESS ) {       // o̓t@C PIK3DCH.csvI[v
		printf("G[ : t@C PIK3DCH.csv J܂.\n");
		exit(1);
	}

	fprintf(fpDAT, "by %s\n", name);
	fprintf(fpDAT, "BY PIK3DCH.CPP\n");
	fprintf(fpDAT, "%13.5f %13.5f\n", RU, ZU );
	fprintf(fpDAT, "%13.5f %13.5f\n", RL, ZL );
	fprintf(fpDAT, "%13.5f\n", L );
	fprintf( fpDAT, "%13.5f\n", op_time);
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", A_amp.x*RD , A_amp.y*RD , A_amp.z*RD  );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", A_phase.x*RD , A_phase.y*RD , A_phase.z*RD  );
	fprintf( fpDAT, "%13.5f %13.5f %13.5f\n", A_period.x , A_period.y , A_period.z  );

	fprintf(fpCSV, "%s\n", name);
	fprintf(fpCSV,
		"TIME, Roll, dRoll, ddRoll, Pitch, dPitch, ddPitch, Yaw, dYaw, ddYaw, ");
	fprintf(fpCSV,
		"Omgx, dOmgx, Omgy, dOmgy, Omgz, dOmgz, ");
	fprintf(fpCSV,
		"THE1, dTHE1, ddTHE1, THE2, dTHE2, ddTHE2, THE3, dTHE3, ddTHE3 \n");

//---- C[v -----

	for(i=0; i<=500; i++){

		time = ( (double)i)*op_time/500.0;                        // 

        EE3DCH ( time, 
			     A_amp, A_phase, A_period,
			     &A );                                           // vbgtH[̉^vZ
		ier = IK3DCH ( L, PSUM, PLF,
						TLT, dTLT, ddTLT,
						PSLM,
						A,
						TT, dTT, ddTT,
						&OMG,
						PSUF, PPF, PSLF,
						THE );                                          // t^wvZ
		if( ier != SUCCESS ) {
			exit(0);
		}
   
		printf("%7.4f", time );
		printf("%11.4f %11.4f %11.4f", A.RPY.x*RD, A.RPY.y*RD, A.RPY.z*RD );
		printf("\n");

		fprintf(fpDAT, "%7.4f", time );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.x*RD, A.DRPY.x*RD, A.DDRPY.x*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.y*RD, A.DRPY.y*RD, A.DDRPY.y*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", A.RPY.z*RD, A.DRPY.z*RD, A.DDRPY.z*RD );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f %13.6f %13.6f %13.6f", OMG.OMG.x*RD, OMG.DOMG.x*RD, OMG.OMG.y*RD, OMG.DOMG.y*RD, OMG.OMG.z*RD, OMG.DOMG.z*RD);
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[0].v, THE[0].dv, THE[0].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[1].v, THE[1].dv, THE[1].ddv );
		fprintf(fpDAT, "%13.6f %13.6f %13.6f", THE[2].v, THE[2].dv, THE[2].ddv );
		fprintf(fpDAT, "\n" );
		fprintf(fpCSV, "%7.4f,", time );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.x*RD, A.DRPY.x*RD, A.DDRPY.x*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.y*RD, A.DRPY.y*RD, A.DDRPY.y*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", A.RPY.z*RD, A.DRPY.z*RD, A.DDRPY.z*RD );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f, %13.6f, %13.6f, %13.6f,", OMG.OMG.x*RD, OMG.DOMG.x*RD, OMG.OMG.y*RD, OMG.DOMG.y*RD, OMG.OMG.z*RD, OMG.DOMG.z*RD);
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[0].v, THE[0].dv, THE[0].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f,", THE[1].v, THE[1].dv, THE[1].ddv );
		fprintf(fpCSV, "%13.6f, %13.6f, %13.6f", THE[2].v, THE[2].dv, THE[2].ddv );
		fprintf(fpCSV, "\n" );
	}
	fclose(fpDAT);                //@t@CN[Y
	fclose(fpCSV);                //@t@CN[Y 
}
