//------------------------------------------------
// 
//     URxԒ}js[^(PUMA^j
//       ֐߂̂T◯֐쓮
//
//          < JNTUMA.CPP >
//
//  op_time        : 쓮
//  THE_s[6], THE_f[6], THE_d[6] :
//                   ֐ߊplEŏIlE^
//  THE[6]         : ֐ߊpƂ̔
//
//
//     2008. 1.15 쐬 BY ╍
//     2008. 1.21  BY ╍
//     2010. 8.21  BY ╍
//
//-----------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "mech.h"

void JNTPUMA( double op_time, double time, 
			 double THE_s[6], double THE_f[6], double THE_d[6],
			 ANGLE THE[6] )
{
    int i;
	double r,r2,r3,r4,r5, dd, vv, aa;    // ƕϐ

	r = time/op_time;                    // 
	if( r<=0.0 ){
		for( i = 0; i<6; i++ ){
			THE[i].the = THE_s[i];
			THE[i].dthe = 0.0;
			THE[i].ddthe = 0.0;
		}
	}
	else{
		if( r<=1.0 ) {
			r2 = r*r;
			r3 = r2*r;
			r4 = r3*r;
			r5 = r4*r;
			dd = 6.0*r5 - 15.0*r4 + 10.0*r3;
			vv = ( 30.0*r4 - 60.0*r3 + 30.0*r2 )/op_time;
			aa = ( 120.0*r3 - 180.0*r2 + 60.0*r )/op_time/op_time;

			for( i = 0; i<6; i++ ){
				THE[i].the = THE_d[i]*dd + THE_s[i];
				THE[i].dthe = THE_d[i]*vv;
				THE[i].ddthe = THE_d[i]*aa;
			}
		}
		else {
			for( i = 0; i<6; i++ ){
				THE[i].the = THE_f[i];
				THE[i].dthe = 0.0;
				THE[i].ddthe = 0.0;
			}
		}
	}
}
