//----------------------------------------------------------
//      URxԃp}js[^
//        (X`[gvbgtH[j
//@@@@̋t^w̓CN[ht@C
//
//     2008. 1.11  CREATED BY D. MATSUURA
//     2008. 1.14  IMPROVED BY N. IWATSUKI
//     2010. 8.21  IMPROVED BY N. IWATSUKI
//-----------------------------------------------------------

#ifndef __STEWARTP_SUBFUNCTIONS_H
#define __STEWARTP_SUBFUNCTIONS_H

//-----------------------------------------------------
//      URxԃp}js[^
//        (X`[gvbgtH[j
//         ̋@\萔̓ǂݍ݂Ɛݒ
//-----------------------------------------------------
void DRMSTEWARTP( double RU[6], double PSIU[6], double ZU[6], 
			      double RL[6], double PSIL[6], double ZL[6],
  				  double THE0[6],
			      POSITION PJUM[6], POSITION PJLF[6] );

//------------------------------------------------
//      URxԃp}js[^
//        (X`[gvbgtH[j
//          ̓vbgtH[̉^ݒ
//         iT◯֐ŋ쓮j
//------------------------------------------------
void DRESTEWARTP( double *op_time, 
                  VECTOR3 *P_start, VECTOR3 *P_final, VECTOR3 *P_delta,
                  VECTOR3 *A_start, VECTOR3 *A_final, VECTOR3 *A_delta );
//------------------------------------------------
//      URxԃp}js[^
//        (X`[gvbgtH[j
//          ̓vbgtH[̉^vZ
//         iT◯֐ŋ쓮j
//------------------------------------------------
void EESTEWARTP( double op_time, double time, 
                 VECTOR3 P_start, VECTOR3 P_final, VECTOR3 P_delta,
                 VECTOR3 A_start, VECTOR3 A_final, VECTOR3 A_delta,
                 POSITION *P,
                 POSTURE *A );
//----------------------------------------------------
//      URxԃp}js[^
//        (X`[gvbgtH[j
//                ̋t^w
//---------------------------------------------------
int IKSTEWARTP( POSITION PJUM[6], POSITION PJLF[6],
                 double THE0[6],
                 POSITION P,
                 POSTURE A,
                 double TT[3][3] , double dTT[3][3], double ddTT[3][3],
                 AVELOCITY *OMG,
                 POSITION PJUF[6], POSITION PJPF[6],
                 VARIABLE THE[6] );

#endif