//----------------------------------------------------
//
//      URxԃp}js[^
//        (X`[gvbgtH[j
//          ̓vbgtH[̋t^wvZ
//
//          < IKSTEWARTP.CPP >
//
//
//   PJUM[6]        : vbgtH[̋΋ʒu
//                   iWnCWj
//   PJLF[6]        : Î~vbgtH[̋΋ʒu
//                    (Î~WnCWj
//   THE0[6]        : Î~΋􂩂璼i΋܂ł̋
//   P              : vbgtH[̕i^
//   A              : vbgtH[̊p^
//
//   TT[3][3], dTT[3][3], ddTT[3][3] :
//                    vbgtH[̍Wϊsi]uj
//                    Ƃ̔
//   OMG            : vbgtH[̊pxEpx
//   PJUF[6]        : vbgtH[̋΋ʒu
//                   iÎ~WnCWj
//   PJPF[6]        : i΋ʒu(Î~WnCWj
//   THE[6]         : AN`G[^͂Ƃ̔
//
//      ** KvȃTuvO **
//          init_joint
//          RPYTT
//          RPYAVELO 
//          TRANS
//          s_SPS_links
//
//     2007.12.11 쐬 BY ╍
//     2008. 1.21  BY ╍
//     2010. 8.21  BY ╍
//
//---------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"
#include "matrix.h"

int IKSTEWARTP ( POSITION PJUM[6], POSITION PJLF[6],
                  double THE0[6],
                  POSITION P, POSTURE A,
                  double TT[3][3] , double dTT[3][3], double ddTT[3][3],
                  AVELOCITY *OMG,
                  POSITION PJUF[6], POSITION PJPF[6],
                  VARIABLE THE[6] )
{

	VECTOR3 wm1;
	POSITION PF;
	int i;                       // ƕϐ
    int ier;

    init_joint( &PF );

//---- Wϊs ----

	RPYTT ( A, TT, dTT, ddTT );

//---- vbgtH[̊pxEpx ----

	RPYAVELO ( A, OMG );

//---- vbgtH[̋΋̕ψʂƂ̔ ----

	for(i=0;i<6;i++)  {

		wm1.x = PJUM[i].P.x;
		wm1.y = PJUM[i].P.y;
		wm1.z = PJUM[i].P.z;

		TRANS ( wm1, P, TT, dTT, ddTT, &PF );

		PJUF[i].P.x = PF.P.x;
		PJUF[i].P.y = PF.P.y;
		PJUF[i].P.z = PF.P.z;

		PJUF[i].DP.x = PF.DP.x;
		PJUF[i].DP.y = PF.DP.y;
		PJUF[i].DP.z = PF.DP.z;

		PJUF[i].DDP.x = PF.DDP.x;
		PJUF[i].DDP.y = PF.DDP.y;
		PJUF[i].DDP.z = PF.DDP.z;
	}

//---- AN`G[^͂̌vZ ----

	for(i=0;i<6;i++) {
		ier = s_SPS_links ( PJLF[i], PJUF[i],
					        THE0[i],
							&PJPF[i],
							&THE[i] );
		if( ier !=SUCCESS )  return ERROR;
	}
	return SUCCESS;
}
